<?php
namespace Teknisa\CDP\Modules\Producao\Controllers;

    use \Teknisa\GER\Libraries\PHPMailer;
    use Teknisa\GER\Controllers\TeknisaCrud;
    use Teknisa\GER\Controllers\CrudController;
    use Zeedhi\Framework\DTO;
    use Zeedhi\Framework\DTO\Response\Error;
    use \Zeedhi\Framework\DataSource\DataSet;
    use Zeedhi\Framework\DataSource\ParameterBag;

    class Cdp06100TarefasDaProducaoController extends TeknisaCrud {
        protected $dataSourceName = 'descinsaudit_roteiroProducao';
  
        public function __construct($crudService, ParameterBag $parameterBag){
            parent::__construct($crudService, $parameterBag);
        }
        
        public function SaveDescinsaudit(DTO\Request $request, DTO\Response $response) {
            $row = $request->getRow();
            $row["TXINSPECAUDI"] = bin2hex($row["TXINSPECAUDI"]);
            $newRequest = new DTO\Request\Row ($row, '', '', '');
    	    try{
    	        parent::save($newRequest, $response);
    	    } catch(\Exception $e){
    	        $response->setError(new DTO\Response\Error($e->getMessage(),1));
    	    }
	    }
	    
	    public function saveObservacaoAndDados(DTO\Request $request, DTO\Response $response) {
	        
	    }
	    
	    public function saveLiberacaoAndDados(DTO\Request $request, DTO\Response $response) {
	        
	    }
	    
	    public function saveOcorrenciaAndDados(DTO\Request $request, DTO\Response $response) {
	        
	    }
        
    }
?>