function Cdp01100_tarefa_Controller (ZHPromise, Cdp01100_tarefa_Service, templateManager, restEngine, General, ScreenService, cdp02200_grupo_de_equipamentoService){
  
    var CDFILIAL;
    var CDPICTINSPEC;
    var mask = {
        "type": "fix",
        "params": {
            "mask": "@getLocalVar('CDP_CDPICTINSPEC')@"
        }
    };
    var nivel_array = [];
    var nivel_max;
    
    this.getMask = function(){
       Cdp01100_tarefa_Service.retornaFilial().then(function(operadorLogado){
            CDFILIAL =  operadorLogado[0].CDFILIAL;
            
            var filtro = [];
            
            General.callRestEngine("cdp#/crud/paramgeral","FilterData", filtro).then(function(sucess){
                if(sucess.dataset.paramgeral.length > 0){
                    CDPICTINSPEC = sucess.dataset.paramgeral[0].CDPICTINSPEC;
                    setLocalVar('CDP_CDPICTINSPEC',CDPICTINSPEC);
                    nivel_array = CDPICTINSPEC.split('.');
                    nivel_max = nivel_array.length;
                    templateManager.container.getWidget('cdp01100_tarefa_tree').getField('CDARVINSPEC').maxlength =  CDPICTINSPEC.replace(/\./g, "").length;
                    templateManager.container.getWidget('cdp01100_tarefa_tree').getField('CDARVINSPEC').mask =  mask;
                    templateManager.container.getWidget('cdp01100_tarefa_tree').reload();
                } else {
                    ScreenService.showMessage("Base não possui parametrezição");
                }
            }, function(error){
                ScreenService.showMessage(error);
            });
            
        }, function(error){
            ScreenService.showMessage(error);
        });
            
    };
    
    this.verificaNivel = function(widget){
       
       if(widget.mode != "edit"){
           if(widget.currentRow.CDNVINSPECAO == nivel_max){
                widget.actions.forEach( function(element){
                   if((element.name == "ADD") && (element.showAsAction == "view")){
                       element.isVisible = false;
                       widget.widgets.forEach(function(elem){
                                elem.enabled = true;
                       });
                   }
               });
           } else {
                widget.actions.forEach( function(element){
                   if((element.name == "ADD") && (element.showAsAction == "view")){
                       element.isVisible = true;
                       widget.widgets.forEach(function(elem){
                            if( elem.name == "widgetDescInsp" ){
                                elem.enabled = true;
                            } else {
                                elem.enabled = false;
                            }
                       });
                    }
               });
           }
       }
       
    };

    this.openDescricao = function(widget){
        widget.dataSourceFilter = [];
        var filtro = [
            {
                "name": "CDINSPECAO",
                "operator": "=",
                "value": widget.parent.currentRow.CDINSPECAO
            }
        ];
       General.callRestEngine("cdp#/crud/descinspecao_tarefa","FilterData", filtro).then(function(sucess){
            if(widget.mode != "edit"){
                widget.currentRow = {};
                if(sucess.dataset.descinspecao_tarefa.length > 0){    
                    widget.currentRow = sucess.dataset.descinspecao_tarefa[0];
                    widget.view();
                } else if(Object.keys(widget.currentRow).length == 0){
                    ScreenService.showMessage('Descrição da Tarefa '+widget.parent.currentRow.NMINSPECAO+' não cadastrada');
                    widget.currentRow.CDINSPECAO = widget.parent.currentRow.CDINSPECAO;
                    widget.currentRow.CDARVINSPEC = widget.parent.currentRow.CDARVINSPEC;
                    widget.currentRow.NMINSPECAO = widget.parent.currentRow.NMINSPECAO;
                    widget.currentRow.__is_new = true;
                    widget.currentRow.TXDESCINSPEC_CLOB = "";
                    widget.view();
                }  else if(sucess.dataset.descinspecao_tarefa.length == 0){
                    widget.currentRow.TXDESCINSPEC_CLOB = "";
                }
            }
        });
    };

    this.newRow = function(widget){
        widget.newRow();
        widget.widgets.forEach(function(element){
            element.enabled = false;
        });
        widget.getField('CDARVINSPEC').mask = null;
        widget.getField('CDARVINSPEC').reload();
        widget.currentRow.IDTPRESPINSP = "NADA";  
        widget.currentRow.IDORIGINSPEC = "TAR";
        widget.currentRow.IDATEITEINSP = "F";
    };
    
    this.newRowView = function(widget){
        var CDARVINSPEC = widget.currentRow.CDARVINSPEC;  
        widget.newRow();
        widget.widgets.forEach(function(element){
            element.enabled = false;
        });
        widget.getField('CDARVINSPEC').mask = null;
        widget.getField('CDARVINSPEC').reload();
        widget.getField('CDARVINSPECANTE').isVisible = true;
        widget.getField('CDARVINSPECANTE').reload();
        //widget.currentRow.CDARVINSPEC = CDARVINSPEC;  
        widget.currentRow.CDARVINSPECANTE = CDARVINSPEC;  
        widget.currentRow.IDTPRESPINSP = "NADA";  
        widget.currentRow.IDORIGINSPEC = "TAR";
        widget.currentRow.IDATEITEINSP = "F";
    };
    
    this.verificaCdArvOnInput = function(widget){
        String.prototype.isNumber = function(){
            return /^\d+$/.test(this);
        };
        if(widget.currentRow.CDARVINSPEC){    
            var tamanho = widget.currentRow.CDARVINSPEC.length;
            var verficaCDPICTINSPEC = CDPICTINSPEC.replace(/\./g, "");
            if(verficaCDPICTINSPEC[(tamanho - 1)].isNumber() == false){
                if(widget.currentRow.CDARVINSPEC[(tamanho - 1)].match(/^[a-zA-Z-0-9]+$/) == null){
                    widget.currentRow.CDARVINSPEC = widget.currentRow.CDARVINSPEC.substring(0,(tamanho - 1));
                    ScreenService.alertNotification("A mascara do campo é "+CDPICTINSPEC+". Dígite um código semelhante, sem os pontos");
                }
            } else if(verficaCDPICTINSPEC[(tamanho - 1)].isNumber() == true){
                if(widget.currentRow.CDARVINSPEC[(tamanho - 1)].isNumber() == false){
                    widget.currentRow.CDARVINSPEC = widget.currentRow.CDARVINSPEC.substring(0,(tamanho - 1));
                    ScreenService.alertNotification("A mascara do campo é "+CDPICTINSPEC+". Dígite um código semelhante, sem os pontos");
                }
            }
        }
    };
    
    this.verificaCdArv = function(widget){
        String.prototype.isNumber = function(){
            return /^\d+$/.test(this);
        };
        
        var tamanho = 0;
        var i = 0;
        
        if(widget.currentRow.CDARVINSPEC.length <= CDPICTINSPEC.replace(/\./g, "").length){    
            while(widget.currentRow.CDARVINSPEC.length > tamanho){
                tamanho += nivel_array[i].length;
                i++;
            }
            if(tamanho > widget.currentRow.CDARVINSPEC.length){
                ScreenService.showMessage('Para preencher o código de nivel '+i+' é necessario que o campo código contenha '+tamanho+' números.');
                widget.currentRow.CDARVINSPEC = "";
                widget.getField('CDARVINSPEC').reload();
                widget.currentRow.CDARVINSPECANTE = "";
                widget.getField('CDARVINSPECANTE').reload();
                widget.currentRow.CDNVINSPECAO = "";
                widget.getField('CDNVINSPECAO').reload();
            } else if(tamanho == widget.currentRow.CDARVINSPEC.length){
                widget.currentRow.CDNVINSPECAO = i;
                if(widget.currentRow.CDNVINSPECAO == 1){
                    widget.currentRow.CDARVINSPECANTE = null;
                } else if(widget.currentRow.CDNVINSPECAO > 1){
                    var remove = - nivel_array[(widget.currentRow.CDNVINSPECAO - 1)].length;
                    widget.currentRow.CDARVINSPECANTE = widget.currentRow.CDARVINSPEC.slice(0, remove); 
                }
            }
        } else if(widget.currentRow.CDARVINSPEC.length > CDPICTINSPEC.replace(/\./g, "").length){
            ScreenService.showMessage('Tamanho maximo do código é '+CDPICTINSPEC.replace(/\./g, "").length);
            widget.currentRow.CDARVINSPEC = "";
            widget.getField('CDARVINSPEC').reload();
            widget.currentRow.CDARVINSPECANTE = "";
            widget.getField('CDARVINSPECANTE').reload();
            widget.currentRow.CDNVINSPECAO = "";
            widget.getField('CDNVINSPECAO').reload();
        }
    };
    
    this.saveArvoreInsp = function(widget){
        var row = widget.currentRow;
        if (widget.isValid()) {
            General.callRestEngine('cdp_producao#/tarefa_inspecao/save', "Row", row).then(function(sucess) {
				widget.activate();
				if (widget.currentRow.__is_new) {
    				if(widget.getField('CDARVINSPECANTE').isVisible == true){
        				widget.getField('CDARVINSPECANTE').isVisible = false;
                        widget.getField('CDARVINSPECANTE').reload();
    				}
    				widget.getField('CDARVINSPEC').mask =  mask;
                    widget.list();  
					ScreenService.goBack();
					widget.reload();
				} else {
					widget.view();
					widget.getField('CDARVINSPEC').mask =  mask;
            	}
				ScreenService.showMessage('Salvo com sucesso');
				this.verificaNivel(widget);
			}.bind(this), function(error){
			    ScreenService.showMessage(error.data.error);
			});
        }
    };
    
    this.deleteArvoreInsp = function(widget){
        ScreenService.confirmMessage(ScreenService.i18n('Delete Register?'), 'question', function (success) {
		    var row = widget.currentRow;
            General.callRestEngine('cdp_producao#/tarefa_inspecao/remove', "Row", row).then(function(sucess) {
        	    ScreenService.closeSwipe().then(function() {
                    widget.list();
                    widget.reload();
                });
        	    ScreenService.showMessage('Deletado com sucesso');
    		}.bind(this), function(error){
    		    ScreenService.showMessage(error.data.error);
    		});
        General.changeWidgetAcessibility(widget.widgets, true);
        });
    };
  
    this.backOrCancelArvoreInspec = function(args){
        if(args.owner.widget.currentRow.__is_new){    
            if(args.owner.widget.getField('CDARVINSPECANTE').isVisible == true){
				args.owner.widget.getField('CDARVINSPECANTE').isVisible = false;
                args.owner.widget.getField('CDARVINSPECANTE').reload();
			}
            General.backOrCancel(args);
            args.owner.widget.getField('CDARVINSPEC').mask =  mask;
        } else {
            General.backOrCancel(args);
        }
        this.verificaNivel(args.owner.widget);
    };
    
    this.newRowChecklist = function(widget){
        widget.newRow();
        widget.currentRow.CDINSPECAO = widget.parent.currentRow.CDINSPECAO;
        widget.currentRow.CDARVINSPEC = widget.parent.currentRow.CDARVINSPEC;
        widget.currentRow.NMINSPECAO = widget.parent.currentRow.NMINSPECAO;
        widget.currentRow.CDNVINSPECAO = widget.parent.currentRow.CDNVINSPECAO;
        widget.currentRow.IDSITINSPEC = widget.parent.currentRow.IDSITINSPEC;
        widget.currentRow.IDTPRESPINSP = widget.parent.currentRow.IDTPRESPINSP;
        widget.currentRow.DSLIMIRESP = widget.parent.currentRow.DSLIMIRESP;
        widget.currentRow.IDORIGINSPEC = widget.parent.currentRow.IDORIGINSPEC;
        widget.currentRow.IDATEITEINSP = widget.parent.currentRow.IDATEITEINSP;
    };
    
    this.editInspecTree = function(widget){
        General.changeWidgetAcessibility(widget.widgets, false);
        General.edit(widget);
    };
    
    this.editDesc = function(widget){
        widget.parent.enabled = false;
        widget.parent.widgets.forEach(function(element){
            if(element.name != widget.name){
                element.enabled = false;
            }
        });
        widget.template = widget.templateToForm;
        General.edit(widget);
    };
    
    this.cancelDesc = function(args){
        var widget = args.owner.widget;
        widget.template = widget.templateToView;
	    widget.view();
        widget.parent.enabled = true;
        widget.parent.widgets.forEach(function(element){
            if(element.name != widget.name){
                element.enabled = true;
            }
        });
        this.openDescricao(widget);
        this.verificaNivel(widget.parent);
    };
    
    this.deleteDesc = function(widget){
        ScreenService.confirmMessage(ScreenService.i18n('Delete Register?'), 'question', function (success) {
			widget.removeRow().then(function () {
                widget.template = widget.templateToView;
    		    widget.view();
                widget.parent.enabled = true;
                widget.parent.widgets.forEach(function(element){
                    if(element.name != widget.name){
                        element.enabled = true;
                    }
                });
                this.openDescricao(widget);
                this.verificaNivel(widget.parent);
            }.bind(this));
        }.bind(this));
    };
    
    this.saveDesc = function(widget){
        if(widget.currentRow.__is_new == true){
            widget.saveRow().then(function(sucess){
                widget.template = widget.templateToView;
                widget.view();
                widget.parent.enabled = true;
                this.verificaNivel(widget.parent);
            }.bind(this));
        } else if(widget.currentRow.__is_new == false){
            Cdp01100_tarefa_Service.updateDesc(widget.currentRow).then(function(sucess){
                widget.template = widget.templateToView;
                widget.view();
                widget.parent.enabled = true;
                this.verificaNivel(widget.parent);
            }.bind(this));
        }
    };
    
}
Configuration(function(ContextRegister) {
    ContextRegister.register('Cdp01100_tarefa_Controller', Cdp01100_tarefa_Controller);
});
