function Ger13500_departamentoController (templateManager, ScreenService, General){
    
    this.setCdfilial = function(){
        var cdfilial = templateManager.container.getWidget('widgetDepartamento').currentRow.CDFILIAL;
        var campocdfilial = templateManager.container.getWidget('widgetDepartamento').getField('CDFILIPEDORC');
        campocdfilial.setValue(cdfilial);
        campocdfilial.reload();
    };
    
    this.createDepart = function(widget) {
        widget.reload();
        widget.newRow();
        widget.currentRow.__is_new = true;
    };
	
	this.edit = function(widget){
        widget.backupRow = Util.clone(widget.currentRow);
        widget.edit();
    };
    
    this.cancel = function(args, widget){
        if(widget.currentRow.__is_new === true){
            widget.dataSource.data.pop();
            ScreenService.closeSwipe();
        } else {
            Util.extend(widget.currentRow, widget.backupRow);
            widget.view();
        }
        this.reload(args);
    };
    
    this.reload = function(args) {
        var widgetDepartamento = templateManager.container.getWidget("widgetDepartamento");
        widgetDepartamento.reload();
    };
    
    this.verificaCodigo = function(){
        var codigo = templateManager.container.getWidget('widgetDepartamento').getField('CDDEPTO').value();
        if(isNaN(codigo)){
            ScreenService.showMessage("O campo 'Departamento' deve conter apenas números");
            templateManager.container.getWidget('widgetDepartamento').getField('CDDEPTO').setValue('');
        }
    };
	
      
}
Configuration(function(ContextRegister) {
    ContextRegister.register('Ger13500_departamentoController', Ger13500_departamentoController);
});