function cdp07700_calendario_de_producao_Controller (ZHPromise, templateManager, restEngine, General, ScreenService, cdp07700_calendario_de_producao_Service){
    
    this.filialCalendario = function(widget){
        if(widget.currentRow.NMFILIAL == ""){
            widget.getField('NMPERIPRODU').readOnly = true;
            widget.getField('NMPERIPRODU').value("");
            widget.getField('NMPERIPRODU').reload();
            widget.widgets[0].isVisible = false;
            this.escondeActions(widget);
            widget.widgets[0].reload();
        } else {
            widget.getField('NMPERIPRODU').readOnly = false;
        }
    };
    
    this.periCalendario = function(widget){
        if(widget.currentRow.NMPERIPRODU == ""){
            widget.widgets[0].isVisible = false;
            this.escondeActions(widget);
            widget.widgets[0].reload();
        } else {
            widget.widgets[0].isVisible = true;
            this.mostraActions(widget);
            widget.widgets[0].reload();
            this.coloreCalendario(widget.widgets[0]);
            widget.widgets[0].reload();
        }
    };
 
    this.escondeActions = function (widget){
        var tamanho = widget.widgets[0].actions.length;
        for(var i = 0; i<tamanho; i++){
            widget.widgets[0].actions[i].isVisible = false;
        }
    };
    
    this.mostraActions = function (widget){
        var tamanho = widget.widgets[0].actions.length;
        for(var i = 0; i<tamanho; i++){
            widget.widgets[0].actions[i].isVisible = true;
        }
    };
    
    this.anoAnteior = function(widget){
        
        if(widget.getYear() > moment().format().substring(0,4)){
            this.mostraActions(widget.parent);
            
        } else if(widget.getYear() < moment().format().substring(0,4)){
            this.escondeActions(widget.parent);
        } else if(widget.getYear() == moment().format().substring(0,4)){
            if((widget.getMonth() + 1).toString().length == 1){
                if((('0'+(widget.getMonth() + 1).toString()+'/'+widget.getYear().toString()) < (moment().format().substring(0,7).split("-").reverse().join("-").replace(/-/g, "/")))){
                    this.escondeActions(widget.parent);
                } else {
                    this.mostraActions(widget.parent);
                }
            } else if((widget.getMonth() + 1).toString().length == 2){
                if((((widget.getMonth() + 1).toString()+'/'+ widget.getYear().toString()) < (moment().format().substring(0,7).split("-").reverse().join("-").replace(/-/g, "/")))){
                    this.escondeActions(widget.parent);
                } else {
                    this.mostraActions(widget.parent);
                }
            }
        }
        
    };
    
    this.coloreCalendario = function(widget){
        
        //Tamanho do mes quem vem do dataSource
        var calendario_BD = widget.dataSource.data;
        var tamanho_mes_BD = widget.dataSource.data.length;
        if(tamanho_mes_BD > 0){
            var i = 0;
            var j = 0;
            widget.selectedDates = [];
            
            var mes = (widget.getMonth() + 1);
            
            if(mes.toString().length == 1){
                mes = widget.getYear().toString()+'-0'+(widget.getMonth() + 1).toString();
            } else if(mes.toString().length == 2){
                mes= widget.getYear().toString()+'-'+(widget.getMonth() + 1).toString();
            }
                
            for(i=0; i<tamanho_mes_BD; i++){
			    if(mes == calendario_BD[i].DTPRODUCAO.substring(0,10).replace(/\//g, "-").split("-").reverse().join("-").substring(0,7)){
			        widget.selectedDates[j] = calendario_BD[i].DTPRODUCAO.substring(0,10).replace(/\//g, "-").split("-").reverse().join("-").substring(0,10);
			        j++;
			    }
            }
            
        }
        
    };
   
    this.calcularProducaoAnual = function(widget){
        
        var tamanho_mes_BD = widget.dataSource.data.length;
        var i = 0;
        var existe = 0;
        
        for(i=0; i < tamanho_mes_BD; i++){
            if(widget.getYear().toString() === widget.dataSource.data[i].DTPRODUCAO.substring(6,10)){
        		existe++;
            }
        } 

        if(existe === 0){
            
            if(widget.getYear().toString() === moment().format().substring(0,4)){
            
                widget.parent.currentRow.DTINICIAL = '01/'+moment().format().substring(5,7)+'/'+widget.getYear().toString()+' 00:00:00';
                widget.parent.currentRow.NRMESES = (12 - parseInt(moment().format().substring(5,7))) + 1;
                widget.parent.currentRow.DTPROCESSA = moment().format().substring(0,10).split("-").reverse().join("-").replace(/-/g, "/")+' 00:00:00';
                
                cdp07700_calendario_de_producao_Service.calcularProdAnual(widget.parent.currentRow).then(
                    function(Success) {
                        ScreenService.closeSwipe().then(function () {
                            widget.activate();
                        });
                        ScreenService.closeSwipe();
                        ScreenService.closePopup();
                        ScreenService.goBack();
                        widget.reload().then( function(){
                            this.coloreCalendario(widget);
                        }.bind(this));
                    }.bind(this),
                    function(error){
                        if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
                            ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
                        } else {
                            ScreenService.showMessage(error.message);
                        }
                    }
                );
                
            } else if(widget.getYear().toString() > moment().format().substring(0,4)){
                
                widget.parent.currentRow.DTINICIAL = '01/01/'+widget.getYear().toString()+' 00:00:00';
                widget.parent.currentRow.NRMESES = 12;
                widget.parent.currentRow.DTPROCESSA = moment().format().substring(0,10).split("-").reverse().join("-").replace(/-/g, "/")+' 00:00:00';
                
                cdp07700_calendario_de_producao_Service.calcularProdAnual(widget.parent.currentRow).then(
                    function(Success) {
                       ScreenService.closeSwipe().then(function () {
                            widget.activate();
                            ScreenService.closePopup();
                            ScreenService.goBack();
                        });
                        widget.reload().then( function(){
                            this.coloreCalendario(widget);
                        }.bind(this));
                    }.bind(this),
                    function(error){
                        if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
                            ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
                        } else {
                            ScreenService.showMessage(error.message);
                        }
                    }
                );
                
                this.coloreCalendario(widget);

            }
       
        } else{
            
            if(widget.getYear().toString() === moment().format().substring(0,4)){
                
                widget.parent.currentRow.ANODELETA = widget.getYear();
                widget.selectedDates = [];
                
                cdp07700_calendario_de_producao_Service.deleteCalendario(widget.parent.currentRow).then(
                    function(Success) {
                        
                        widget.parent.currentRow.DTINICIAL = '01/'+moment().format().substring(5,7)+'/'+widget.getYear().toString()+' 00:00:00';
                        widget.parent.currentRow.NRMESES = (12 - parseInt(moment().format().substring(5,7))) + 1;
                        widget.parent.currentRow.DTPROCESSA = moment().format().substring(0,10).split("-").reverse().join("-").replace(/-/g, "/")+' 00:00:00';
                        
                        cdp07700_calendario_de_producao_Service.calcularProdAnual(widget.parent.currentRow).then(
                            function(Success) {
                                ScreenService.closeSwipe().then(function () {
                                    widget.activate();
                                });
                                widget.reload();
                            },
                            function(error){
                                if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
                                    ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
                                } else {
                                    ScreenService.showMessage(error.message);
                                }
                            }
                        );
                        ScreenService.closeSwipe().then(function () {
                            widget.activate();
                        });
                        ScreenService.closeSwipe();
                        ScreenService.closePopup();
                        ScreenService.goBack();
                    },
                    function(error){
                        if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
                            ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
                        } else {
                            ScreenService.showMessage(error.message);
                        }
                    }
                );
            
            } else {
                
                widget.parent.currentRow.ANODELETA = widget.getYear();
                widget.selectedDates = [];
                widget.parent.currentRow.DTINICIAL = '01/01/'+widget.getYear().toString()+' 00:00:00';
                widget.parent.currentRow.NRMESES = 12;
                widget.parent.currentRow.DTPROCESSA = moment().format().substring(0,10).split("-").reverse().join("-").replace(/-/g, "/")+' 00:00:00';
                
                cdp07700_calendario_de_producao_Service.deleteCalendario(widget.parent.currentRow).then(
                    function(Success) {
                        
                        cdp07700_calendario_de_producao_Service.calcularProdAnual(widget.parent.currentRow).then(
                            function(Success) {
                                ScreenService.closeSwipe().then(function () {
                                    widget.activate();
                                });
                                widget.reload();
                            },
                            function(error){
                                if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
                                    ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
                                } else {
                                    ScreenService.showMessage(error.message);
                                }
                            }
                        );
                        ScreenService.closeSwipe().then(function () {
                            widget.activate();
                        });
                        ScreenService.closeSwipe();
                        ScreenService.closePopup();
                        ScreenService.goBack();
                    },
                    function(error){
                        if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
                            ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
                        } else {
                            ScreenService.showMessage(error.message);
                        }
                    }
                );

            }
            
        } 
    };
    
    this.CalcularProduCaoMensal = function(widget){
        
        var calendario_BD = widget.dataSource.data;
        var tamanho_mes_BD = widget.dataSource.data.length;
        var data_mes = 0;
        var i = 0;
        var existe = 0;
        
        if(((widget.getMonth() + 1).toString().length == 1)){
            data_mes = '0'+(widget.getMonth() + 1).toString()+'/'+widget.getYear().toString();
        } else if(((widget.getMonth() + 1).toString().length == 2)){
            data_mes = (widget.getMonth() + 1).toString()+'/'+widget.getYear().toString();
        } 
        
        for(i=0; i < tamanho_mes_BD; i++){
            if(data_mes === widget.dataSource.data[i].DTPRODUCAO.substring(3,10)){
        		existe++;
            }
        } 

        if(existe === 0){
            
            if(data_mes.replace(/\//g, "-").split("-").reverse().join("-") === moment().format().substring(0,7)){
            
                widget.parent.currentRow.DTINICIAL = '01/'+moment().format().substring(5,7)+'/'+widget.getYear().toString()+' 00:00:00';
                widget.parent.currentRow.NRMESES = 1;
                widget.parent.currentRow.DTPROCESSA = moment().format().substring(0,10).split("-").reverse().join("-").replace(/-/g, "/")+' 00:00:00';
                
                cdp07700_calendario_de_producao_Service.calcularProdAnual(widget.parent.currentRow).then(
                    function(Success) {
                        ScreenService.closeSwipe().then(function () {
                            widget.activate();
                        });
                        ScreenService.closeSwipe();
                        ScreenService.closePopup();
                        ScreenService.goBack();
                        widget.reload().then( function(){
                            this.coloreCalendario(widget);
                        }.bind(this));
                    }.bind(this),
                    function(error){
                        if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
                            ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
                        } else {
                            ScreenService.showMessage(error.message);
                        }
                    }
                );
              
            } else  if(data_mes.replace(/\//g, "-").split("-").reverse().join("-") > moment().format().substring(0,7)){
            
                widget.parent.currentRow.DTINICIAL = '01/'+data_mes+' 00:00:00';
                widget.parent.currentRow.NRMESES = 1;
                widget.parent.currentRow.DTPROCESSA = moment().format().substring(0,10).split("-").reverse().join("-").replace(/-/g, "/")+' 00:00:00';
                
                cdp07700_calendario_de_producao_Service.calcularProdAnual(widget.parent.currentRow).then(
                    function(Success) {
                       ScreenService.closeSwipe().then(function () {
                            widget.activate();
                        }); 
                        ScreenService.closeSwipe();
                        ScreenService.closePopup();
                        ScreenService.goBack();
                        widget.reload().then( function(){
                            this.coloreCalendario(widget);
                        }.bind(this));
                    }.bind(this),
                    function(error){
                        if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
                            ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
                        } else {
                            ScreenService.showMessage(error.message);
                        }
                    }
                );
                
            }
       
        } else {
            
            if(data_mes.replace(/\//g, "-").split("-").reverse().join("-") === moment().format().substring(0,7)){
                
                
                if(widget.getMonth().toString().length == 1){
                    widget.parent.currentRow.ANODELETA = '0'+(widget.getMonth() + 1).toString()+'/'+widget.getYear().toString();
                } else if(widget.getMonth().toString().length == 2){
                    widget.parent.currentRow.ANODELETA = (widget.getMonth() + 1).toString()+'/'+widget.getYear().toString();
                } 
                widget.selectedDates = [];
                widget.parent.currentRow.DTINICIAL = '01/'+moment().format().substring(5,7)+'/'+widget.getYear().toString()+' 00:00:00';
                widget.parent.currentRow.NRMESES = 1;
                widget.parent.currentRow.DTPROCESSA = moment().format().substring(0,10).split("-").reverse().join("-").replace(/-/g, "/")+' 00:00:00';
                
                
                cdp07700_calendario_de_producao_Service.deleteCalendario(widget.parent.currentRow).then(
                    function(Success) {
                        
                        cdp07700_calendario_de_producao_Service.calcularProdAnual(widget.parent.currentRow).then(
                            function(Success) {
                                ScreenService.closeSwipe().then(function () {
                                    widget.activate();
                                });
                                widget.reload();
                            },
                            function(error){
                                if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
                                    ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
                                } else {
                                    ScreenService.showMessage(error.message);
                                }
                            }
                        );
                        ScreenService.closeSwipe().then(function () {
                            widget.activate();
                        });
                        ScreenService.closeSwipe();
                        ScreenService.closePopup();
                        ScreenService.goBack();
                    },
                    function(error){
                        if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
                            ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
                        } else {
                            ScreenService.showMessage(error.message);
                        }
                    }
                );
                
            } else {
                ScreenService.showMessage('Não é possivel calcular Produção Mensal. Produção Mensal já cadastrada.');
            }   
            
        }
    };
    
    this.deletarCalendario = function (widget) {
        ScreenService.showCustomDialog('Qual periodo deseja Excluir?', 'question', 'question', [{
            label: ScreenService.i18n("Ano"),
            code: function(){
                widget.parent.currentRow.ANODELETA = widget.getYear();
       
                ScreenService.confirmMessage(ScreenService.i18n('Delete Register?'), 'question', function (success) {
            
                    cdp07700_calendario_de_producao_Service.deleteCalendario(widget.parent.currentRow).then(
                        function(Success) {
                            widget.selectedDates = [];
                            ScreenService.closeSwipe().then(function () {
                                widget.activate();
                            });
                            widget.reload();
                        },
                        function(error){
                            if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
                                ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
                            } else {
                                ScreenService.showMessage(error.message);
                            }
                        }
                    );
                });
            }.bind(this)
        },{
            label: ScreenService.i18n("Mês"),
            code: function(){
                
                if(((widget.getMonth() + 1).toString().length == 1)){
                    widget.parent.currentRow.ANODELETA = '0'+(widget.getMonth() + 1).toString()+'/'+widget.getYear().toString();
                } else if((widget.getMonth() + 1).toString().length == 2){
                    widget.parent.currentRow.ANODELETA = (widget.getMonth() + 1).toString()+'/'+widget.getYear().toString();
                } 
                
                ScreenService.confirmMessage(ScreenService.i18n('Delete Register?'), 'question', function (success) {
    
                    cdp07700_calendario_de_producao_Service.deleteCalendarioMes(widget.parent.currentRow).then(
                        function(Success) {
                            widget.selectedDates = [];
                            ScreenService.closeSwipe().then(function () {
                                widget.activate();
                            });
                            widget.reload();
                        },
                        function(error){
                            if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
                                ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
                            } else {
                                ScreenService.showMessage(error.message);
                            }
                        }
                    );
                });
            }.bind(this)
        }]);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('cdp07700_calendario_de_producao_Controller', cdp07700_calendario_de_producao_Controller);
});