function cdp26000_controle_prioridade_producaoController (templateManager, restEngine, General, ScreenService, ZHPromise, cdp26000_controle_prioridade_producaoService){
	
	this.widgetSave = function (widget) {
	    try{
    		var isNew; 
    		cdp26000_controle_prioridade_producaoService.checkNewRowPrioriproducao(widget.currentRow).then(function(success){
    		    isNew = success.dataset.checkNewRowPrioriproducao[0];
    		    widget.currentRow.__is_new = isNew;
                widgetSave(widget);
    		}, function (error) {
                var errorMessage = 'Timeout';
                if (error.data) {
                    errorMessage = error.data.error;
                }
                ScreenService.showMessage(errorMessage);
            });
	    } catch (e) {
	        ScreenService.showMessage(e);
	    }
	};
	
	function widgetSave(widget){
	   var deferred = ZHPromise.defer();

		if (widget.isValid()) {
			widget.currentRow.changed = true;

			if (!widget.currentRow.__is_new)
				widget.currentRow.__is_new = false;
			else if (widget.paramsNewCode && widget.paramsNewCode.__is_new_code) {
				widget.currentRow.__using_unit = widget.paramsNewCode.__using_unit || false;
				widget.currentRow.__new_code_pk = widget.paramsNewCode.__new_code_pk;
				widget.currentRow.__table_pk = widget.paramsNewCode.__table_pk;
				widget.currentRow.__new_code_length = widget.paramsNewCode.__new_code_length || 5;
				widget.currentRow.__cast_number = widget.paramsNewCode.__cast_number || false;
			}

			widget.saveRow().then(function (response) {
				widget.currentRow.changed = false;
				delete widget.backupRow;

				if (General.formWidgetSwitchTemplate(widget) && widget.parent) {
					widget.view();

					var widgets = widget.parent.widgets;
					General.changeWidgetAcessibility(widgets.concat(widget.parent), true);
				} else {
					if (widget.currentRow.__is_new) {
						widget.view();
					} else widget.view();

					General.changeWidgetAcessibility(widget.widgets, true);
				}

				if (widget.currentRow.__is_new) widget.currentRow.__is_new = false;
				else widget.reload();

				deferred.resolve(response);
			}, function (error) {
				var errorMessage = 'Timeout';

				if (error.data) errorMessage = error.data.error;

				ScreenService.showMessage(errorMessage);
				deferred.reject(errorMessage);
			});
		} else deferred.reject("Preencha todos os campos corretamente!");

		return deferred;
	}
}   

Configuration(function(ContextRegister) {
    ContextRegister.register('cdp26000_controle_prioridade_producaoController', cdp26000_controle_prioridade_producaoController);
});