<?php
namespace Teknisa\CDP\Modules\Producao\Factories;

use Doctrine\ORM\EntityManager;

class cdp26000ControlePrioridadeProducaoFactory {

    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection       = $entityManager->getConnection();
        $this->entityManager    = $entityManager;
    }

    public function checkNewRowPrioriproducao($params){
        
        
        $sql = "SELECT *
                FROM PRIORIPRODUCAO
                WHERE CDEQUIPPRO = :CDEQUIPPRO
                  AND CDPRODINSUMO = :CDPRODINSUMO
                  AND NRORG = :NRORG";
        
        $std = $this->connection->prepare($sql);
        
        $std->execute($params);
        return $std->fetchAll();
    }
    
}