function Ger11800_inspecao_Controller (Ger11800_inspecao_Service, ZHPromise, templateManager, restEngine, General, ScreenService){
  
    var CDFILIAL;
    var CDPICTINSPEC;
    var CDPICTPROD;
    var mask = {
        "type": "fix",
        "params": {
            "mask": "@getLocalVar('CDP_CDPICTINSPEC')@"
        }
    };
    var nivel_array = [];
    var nivel_max;
    
    this.getMask = function(){
       Ger11800_inspecao_Service.retornaFilial().then(function(filialLogada){
            CDFILIAL =  filialLogada[0].CDFILIAL;
            
            var filtro = [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": CDFILIAL
                }
            ];
            
            General.callRestEngine("cdp#/crud/paramgeral","FilterData", filtro).then(function(sucess){
                CDPICTINSPEC = sucess.dataset.paramgeral[0].CDPICTINSPEC;
                CDPICTPROD = sucess.dataset.paramgeral[0].CDPICTPROD;
                setLocalVar('CDP_CDPICTINSPEC',CDPICTINSPEC);
                setLocalVar('CDP_CDPICTPROD',CDPICTPROD);
                nivel_array = CDPICTINSPEC.split('.');
                nivel_max = nivel_array.length;
                templateManager.container.getWidget('ger11800_inspecao_tree').getField('CDARVINSPEC').maxlength =  CDPICTINSPEC.replace(/\./g, "").length;
                templateManager.container.getWidget('ger11800_inspecao_tree').getField('CDARVINSPEC').mask =  mask;
                templateManager.container.getWidget('ger11800_inspecao_tree').reload();
            
            }, function(error){
                ScreenService.showMessage(error);
            });
            
        }, function(error){
            ScreenService.showMessage(error);
        });
            
    };
    
    this.verificaNivel = function(widget){
       var penNiv = nivel_max - 1;
       penNiv = penNiv.toString();
       
       if(widget.mode != "edit"){
           if(widget.currentRow.CDNVINSPECAO == nivel_max){
               widget.actions.forEach( function(element){
                   if((element.name == "ADD") && (element.showAsAction == "view")){
                       element.isVisible = false;
                       widget.widgets.forEach(function(elem){
                            if((elem.name == "widgetTipodeVistoInspec") || (elem.name == "widgetInspecaoporProdutoInspec")){
                                elem.enabled = false;
                            } else {
                                elem.enabled = true;
                            }
                       });
                   }
               });
           } else if(widget.currentRow.CDNVINSPECAO == penNiv){
               widget.actions.forEach( function(element){
                   if((element.name == "ADD") && (element.showAsAction == "view")){
                       element.isVisible = true;
                       widget.widgets.forEach(function(elem){
                            if((elem.name == "widgetDescInsp") || (elem.name == "widgetTipodeVistoInspec") || (elem.name == "widgetInspecaoporProdutoInspec")){
                                elem.enabled = true;
                            } else {
                                elem.enabled = false;
                            }
                       });
                    }
               });
           } else {
                widget.actions.forEach( function(element){
                   if((element.name == "ADD") && (element.showAsAction == "view")){
                       element.isVisible = true;
                       widget.widgets.forEach(function(elem){
                            if( elem.name == "widgetDescInsp" ){
                                elem.enabled = true;
                            } else {
                                elem.enabled = false;
                            }
                       });
                    }
               });
           }
       }
    };

    this.openDescricao = function(widget){
        widget.dataSource.data = [];
        widget.dataSourceFilter = [];
        var filtro = [
            {
                "name": "CDINSPECAO",
                "operator": "=",
                "value": widget.parent.currentRow.CDINSPECAO
            }
        ];
       General.callRestEngine("cdp#/crud/inspecao_descinspecao","FilterData", filtro).then(function(sucess){
            if(widget.mode != "edit"){
                widget.currentRow = {};
                if(sucess.dataset.inspecao_descinspecao.length > 0){    
                    widget.currentRow = sucess.dataset.inspecao_descinspecao[0];
                    if(widget.currentRow.TXDESCINSPEC_CLOB == null){
                        widget.currentRow.TXDESCINSPEC_CLOB = "";
                    }
                    widget.view();
                } else if(Object.keys(widget.currentRow).length == 0){
                    ScreenService.showMessage('Descrição da Inspeção '+widget.parent.currentRow.NMINSPECAO+' não cadastrada');
                    widget.currentRow.CDINSPECAO = widget.parent.currentRow.CDINSPECAO;
                    widget.currentRow.CDARVINSPEC = widget.parent.currentRow.CDARVINSPEC;
                    widget.currentRow.NMINSPECAO = widget.parent.currentRow.NMINSPECAO;
                    widget.currentRow.TXDESCINSPEC_CLOB = "";
                    widget.currentRow.__is_new = true;
                    widget.view();
                }  else if(sucess.dataset.inspecao_descinspecao.length == 0){
                    widget.currentRow.TXDESCINSPEC_CLOB = "";
                }
            }
        });
    };
    
    this.openAcaoCorretiva = function(widget){
        widget.dataSource.data = [];
        widget.dataSourceFilter = [];
        var filtro = [
            {
                "name": "CDINSPECAO",
                "operator": "=",
                "value": widget.parent.currentRow.CDINSPECAO
            }
        ];
       General.callRestEngine("cdp#/crud/inspecao_acao","FilterData", filtro).then(function(sucess){
            if(widget.mode != "edit"){
                widget.currentRow = {};
                if(sucess.dataset.inspecao_acao.length > 0){    
                    widget.currentRow = sucess.dataset.inspecao_acao[0];
                    if(widget.currentRow.TXACAOINSPEC_CLOB == null){
                        widget.currentRow.TXACAOINSPEC_CLOB = "";
                    } /*else {
                        widget.currentRow.TXACAOINSPEC_CLOB = this.openAcaoCorretivaComplete(widget.currentRow.TXACAOINSPEC_CLOB);
                    }*/
                    widget.view();
                } else if(Object.keys(widget.currentRow).length == 0){
                    ScreenService.showMessage('Descrição da Inspeção '+widget.parent.currentRow.NMINSPECAO+' não cadastrada');
                    widget.currentRow.CDINSPECAO = widget.parent.currentRow.CDINSPECAO;
                    widget.currentRow.CDARVINSPEC = widget.parent.currentRow.CDARVINSPEC;
                    widget.currentRow.NMINSPECAO = widget.parent.currentRow.NMINSPECAO;
                    widget.currentRow.TXACAOINSPEC_CLOB = "";
                    widget.currentRow.__is_new = true;
                    widget.view();
                }  else if(sucess.dataset.inspecao_acao.length == 0){
                    widget.currentRow.TXACAOINSPEC_CLOB = "";
                }
            }
        }.bind(this));
    };

    this.newRow = function(widget){
        General.changeWidgetAcessibility(widget.widgets, false);
        widget.newRow();
        widget.getField('CDARVINSPEC').mask = null;
        widget.getField('CDARVINSPEC').reload();  
        widget.currentRow.IDORIGINSPEC = "QUA";
    };
    
    this.newRowView = function(widget){
        var CDARVINSPEC = widget.currentRow.CDARVINSPEC;  
        General.changeWidgetAcessibility(widget.widgets, false);
        widget.newRow();
        widget.getField('CDARVINSPEC').mask = null;
        widget.getField('CDARVINSPEC').reload();
        widget.getField('CDARVINSPECANTE').isVisible = true;
        widget.getField('CDARVINSPECANTE').reload();
        //widget.currentRow.CDARVINSPEC = CDARVINSPEC;  
        widget.currentRow.CDARVINSPECANTE = CDARVINSPEC;  
        widget.currentRow.IDORIGINSPEC = "QUA";
    };
    
    this.newVisto = function(widget){
        widget.newRow();
        widget.currentRow.CDINSPECAO = widget.parent.currentRow.CDINSPECAO;
        widget.currentRow.CDARVINSPEC = widget.parent.currentRow.CDARVINSPEC;
        widget.currentRow.NMINSPECAO = widget.parent.currentRow.NMINSPECAO;
    };

    this.verificaCdArvOnInput = function(widget){
        String.prototype.isNumber = function(){
            return /^\d+$/.test(this);
        };
        if(widget.currentRow.CDARVINSPEC){    
            var tamanho = widget.currentRow.CDARVINSPEC.length;
            var verficaCDPICTINSPEC = CDPICTINSPEC.replace(/\./g, "");
            if(verficaCDPICTINSPEC[(tamanho - 1)].isNumber() == false){
                if(widget.currentRow.CDARVINSPEC[(tamanho - 1)].match(/^[a-zA-Z-0-9]+$/) == null){
                    widget.currentRow.CDARVINSPEC = widget.currentRow.CDARVINSPEC.substring(0,(tamanho - 1));
                    ScreenService.alertNotification("A mascara do campo é "+CDPICTINSPEC+". Dígite um código semelhante, sem os pontos");
                }
            } else if(verficaCDPICTINSPEC[(tamanho - 1)].isNumber() == true){
                if(widget.currentRow.CDARVINSPEC[(tamanho - 1)].isNumber() == false){
                    widget.currentRow.CDARVINSPEC = widget.currentRow.CDARVINSPEC.substring(0,(tamanho - 1));
                    ScreenService.alertNotification("A mascara do campo é "+CDPICTINSPEC+". Dígite um código semelhante, sem os pontos");
                }
            }
        }
    };  

    this.verificaCdArv = function(widget){
        String.prototype.isNumber = function(){
            return /^\d+$/.test(this);
        };
        
        var espace = false;
        var tamanho = widget.currentRow.CDARVINSPEC.length;
        var i = 0;
        
        for(var j = 0; j < tamanho; j++){
        	if(widget.currentRow.CDARVINSPEC[j] == " "){
        	 	ScreenService.showMessage("Favor inserir o código sem espaço");
        	 	widget.currentRow.CDARVINSPEC = "";
                widget.getField('CDARVINSPEC').reload();
                widget.currentRow.CDARVINSPECANTE = "";
                widget.getField('CDARVINSPECANTE').reload();
                widget.currentRow.CDNVINSPECAO = "";
                widget.getField('CDNVINSPECAO').reload();
                espace = true;
        	}
        }
         
        tamanho = 0; 
         
        if(espace == false){
            if(widget.currentRow.CDARVINSPEC.length <= CDPICTINSPEC.replace(/\./g, "").length){    
                while(widget.currentRow.CDARVINSPEC.length > tamanho){
                    tamanho += nivel_array[i].length;
                    i++;
                }
                if(tamanho > widget.currentRow.CDARVINSPEC.length){
                    ScreenService.showMessage('Para preencher o código de nivel '+i+' é necessario que o campo código contenha '+tamanho+' números.');
                    widget.currentRow.CDARVINSPEC = "";
                    widget.getField('CDARVINSPEC').reload();
                    widget.currentRow.CDARVINSPECANTE = "";
                    widget.getField('CDARVINSPECANTE').reload();
                    widget.currentRow.CDNVINSPECAO = "";
                    widget.getField('CDNVINSPECAO').reload();
                } else if(tamanho == widget.currentRow.CDARVINSPEC.length){
                    widget.currentRow.CDNVINSPECAO = i;
                    if(widget.currentRow.CDNVINSPECAO == 1){
                        widget.currentRow.CDARVINSPECANTE = null;
                    } else if(widget.currentRow.CDNVINSPECAO > 1){
                        var remove = - nivel_array[(widget.currentRow.CDNVINSPECAO - 1)].length;
                        widget.currentRow.CDARVINSPECANTE = widget.currentRow.CDARVINSPEC.slice(0, remove); 
                    }
                }
            } else if(widget.currentRow.CDARVINSPEC.length > CDPICTINSPEC.replace(/\./g, "").length){
                ScreenService.showMessage('Tamanho maximo do código é '+CDPICTINSPEC.replace(/\./g, "").length);
                widget.currentRow.CDARVINSPEC = "";
                widget.getField('CDARVINSPEC').reload();
                widget.currentRow.CDARVINSPECANTE = "";
                widget.getField('CDARVINSPECANTE').reload();
                widget.currentRow.CDNVINSPECAO = "";
                widget.getField('CDNVINSPECAO').reload();
            }
        }
    };
    
    this.saveArvoreInsp = function(widget){
        var row = widget.currentRow;
        if (widget.isValid()) {
            General.callRestEngine('cdp_producao#/inspecao_inspecao/save', "Row", row).then(function(sucess) {
				widget.activate();
				if (widget.currentRow.__is_new) {
    				if(widget.getField('CDARVINSPECANTE').isVisible == true){
        				widget.getField('CDARVINSPECANTE').isVisible = false;
                        widget.getField('CDARVINSPECANTE').reload();
    				}
    				widget.getField('CDARVINSPEC').mask =  mask;
                    widget.list();  
					ScreenService.goBack();
					widget.reload();
				} else {
					widget.view();
					widget.getField('CDARVINSPEC').mask =  mask;
            	}
				ScreenService.showMessage('Salvo com sucesso');
                this.verificaNivel(widget);
			}.bind(this), function(error){
			    ScreenService.showMessage(error.data.error);
			});
        }
    };
    
    this.saveInspecProd = function(widget){
        var row = widget.currentRow;
        if (widget.isValid()) {
            if(widget.currentRow.__is_new){
                Ger11800_inspecao_Service.geraNRSEQINSPRO(widget.currentRow).then(function(sucess){
                	row.NRSEQINSPRO = sucess.dataset.data[0].NRSEQINSPRO;
                	General.saveCrud(widget);
    			}.bind(this), function(error){
    			    ScreenService.showMessage(error.data.error);
    			});
            } else {
        	    General.saveCrud(widget);
            } 
        }
    };
    
    this.deleteArvoreInsp = function(widget){
        ScreenService.confirmMessage(ScreenService.i18n('Delete Register?'), 'question', function (success) {
		    var row = widget.currentRow;
            General.callRestEngine('cdp_producao#/inspecao_inspecao/remove', "Row", row).then(function(sucess) {
        	    ScreenService.closeSwipe().then(function() {
                    widget.list();
                    widget.reload();
                });
        	    ScreenService.showMessage('Deletado com sucesso');
    		}.bind(this), function(error){
    		    ScreenService.showMessage(error.data.error);
    		});
        General.changeWidgetAcessibility(widget.widgets, true);
        });
    };
  
    this.backOrCancelArvoreInspec = function(args){
        if(args.owner.widget.currentRow.__is_new){    
            if(args.owner.widget.getField('CDARVINSPECANTE').isVisible == true){
				args.owner.widget.getField('CDARVINSPECANTE').isVisible = false;
                args.owner.widget.getField('CDARVINSPECANTE').reload();
			}
            General.backOrCancel(args);
            args.owner.widget.getField('CDARVINSPEC').mask =  mask;
        } else {
            General.backOrCancel(args);
        }
        this.verificaNivel(args.owner.widget);
    };
    
    this.newRowChecklist = function(widget){
        widget.newRow();
        widget.currentRow.CDINSPECAO = widget.parent.currentRow.CDINSPECAO;
        widget.currentRow.CDARVINSPEC = widget.parent.currentRow.CDARVINSPEC;
        widget.currentRow.NMINSPECAO = widget.parent.currentRow.NMINSPECAO;
        widget.currentRow.CDNVINSPECAO = widget.parent.currentRow.CDNVINSPECAO;
        widget.currentRow.IDSITINSPEC = widget.parent.currentRow.IDSITINSPEC;
        widget.currentRow.IDTPRESPINSP = widget.parent.currentRow.IDTPRESPINSP;
        widget.currentRow.DSLIMIRESP = widget.parent.currentRow.DSLIMIRESP;
        widget.currentRow.IDORIGINSPEC = widget.parent.currentRow.IDORIGINSPEC;
        widget.currentRow.IDATEITEINSP = widget.parent.currentRow.IDATEITEINSP;
    };
    
    this.editInspecTree = function(widget){
        General.changeWidgetAcessibility(widget.widgets, false);
        General.edit(widget);
    };
    
    this.editDesc = function(widget){
        widget.parent.enabled = false;
        widget.parent.widgets.forEach(function(element){
            if(element.name != widget.name){
                element.enabled = false;
            }
        });
        widget.template = widget.templateToForm;
        General.edit(widget);
    };
    
    this.cancelDesc = function(args){
        var widget = args.owner.widget;
        widget.template = widget.templateToView;
	    widget.view();
        widget.parent.enabled = true;
        this.verificaNivel(widget.parent);
        this.openDescricao(widget);
    };
    
    this.deleteDesc = function(widget){
        ScreenService.confirmMessage(ScreenService.i18n('Delete Register?'), 'question', function (success) {
			widget.removeRow().then(function () {
                widget.template = widget.templateToView;
    		    widget.view();
                widget.parent.enabled = true;
                this.verificaNivel(widget.parent);
                this.openDescricao(widget);
            }.bind(this));
        }.bind(this));
    };
    
    this.saveDesc = function(widget){
        if(widget.currentRow.__is_new == true){
            widget.saveRow().then(function(sucess){
                widget.template = widget.templateToView;
                widget.view();
                widget.parent.enabled = true;
                this.verificaNivel(widget.parent);
            }.bind(this));
        } else if(widget.currentRow.__is_new == false){
            Ger11800_inspecao_Service.updateDesc(widget.currentRow).then(function(sucess){
                widget.template = widget.templateToView;
                widget.view();
                widget.parent.enabled = true;
                this.verificaNivel(widget.parent);
            }.bind(this));
        }
    };
    
    this.editAcaoCorretiva = function(widget){
        widget.parent.enabled = false;
        widget.parent.widgets.forEach(function(element){
            if(element.name != widget.name){
                element.enabled = false;
            }
        });
        widget.template = widget.templateToForm;
        General.edit(widget);
    };
    
    this.cancelAcaoCorretiva = function(args){
        var widget = args.owner.widget;
        widget.template = widget.templateToView;
	    widget.view();
        widget.parent.enabled = true;
        this.verificaNivel(widget.parent);
        this.openAcaoCorretiva(widget);
    };
    
    this.deleteAcaoCorretiva = function(widget){
        ScreenService.confirmMessage(ScreenService.i18n('Delete Register?'), 'question', function (success) {
			widget.removeRow().then(function () {
                widget.template = widget.templateToView;
    		    widget.view();
                widget.parent.enabled = true;
                this.verificaNivel(widget.parent);
                this.openAcaoCorretiva(widget);
            }.bind(this));
        }.bind(this));
    };
    
    this.ascii_to_hexa = function(str){
        var arr1 = [];
    	for (var n = 0, l = str.length; n < l; n ++) {
    	
    		if(Number(str.charCodeAt(n)) > 127){
    		    arr1.push("5c27");
    		    var hex_mf = Number(str.charCodeAt(n)).toString(16);
    		    for (var i = 0, t = hex_mf.length; i < t; i ++) {
    		        var hex_nf = Number(hex_mf.charCodeAt(i)).toString(16);
    		        arr1.push(hex_nf);
    		    }
    		} else {
        		var hex = Number(str.charCodeAt(n)).toString(16);
        		if(hex == "a"){
        		    hex = "0D";
        		}
        		arr1.push(hex);
        	}    
    	}
    	return arr1.join('');
    		
    };
    
    /**
     * 
     * Campo TXACAOINSPEC (Long Raw) estourando quando atinge 4000 caracteres;
     * 
     * Foi necessário criar um campo CLOB para ser possivvél que o campo tenha
     * a mesma funcionalidade do delphi, no mobile;
     * 
     * Basicamente o Mobile salva em HTML e o Delphi não reconhece o mesmo, 
     * exibindo para o usario além dos textos as tags;
     * 
     * Foi criado duas funções abaixo para identificar caracteres que não são
     * reconhecidos pelo zeedhi e exibilos corretamente.
     * 
     * Funções salvas e commitadas em comentario para uso posterior.
     * 
    */
    
    /*
    this.openAcaoCorretivaComplete = function(str){
        var arr1 = [];
    	for (var n = 0, l = str.length; n < l; n ++) {
    	
    		if((Number(str.charCodeAt(n)).toString(16) == "5c") && (Number(str.charCodeAt(n+1)).toString(16) == "27")){
    		    var hex_mf = this.hex_to_ascii(str.substring(n+2,n+4));
    		    arr1.push(hex_mf);
    		    n = n+3;
    		} else {
        		arr1.push(str[n]);
        	}    
    	}
    	return arr1.join('');
    		
    };
    
    this.hex_to_ascii = function(str1){
    	var hex  = str1.toString();
    	var str = '';
    	for (var n = 0; n < hex.length; n += 2) {
    		str += String.fromCharCode(parseInt(hex.substr(n, 2), 16));
    	}
    	return str;
    };
    */
    
    this.saveAcaoCorretiva = function(widget){
        widget.saveRow().then(function(sucess){
            widget.template = widget.templateToView;
            widget.view();
            widget.parent.enabled = true;
            this.verificaNivel(widget.parent);
        }.bind(this), function(error){
            console.log('Erro ao salvar Ação Corretiva');
        });
    };
    
    this.newRowOpcao = function(widget){
        widget.newRow();
        widget.currentRow.CDINSPECAO = widget.parent.currentRow.CDINSPECAO;
        widget.currentRow.CDARVINSPEC = widget.parent.currentRow.CDARVINSPEC;
        widget.currentRow.NMINSPECAO = widget.parent.currentRow.NMINSPECAO;
    };
    
    this.newRowInspecProd = function(widget){
        widget.newRow();
        widget.currentRow.CDINSPECAO = widget.parent.currentRow.CDINSPECAO;
        widget.currentRow.CDARVINSPEC = widget.parent.currentRow.CDARVINSPEC;
        widget.currentRow.NMINSPECAO = widget.parent.currentRow.NMINSPECAO;
        //widget.currentRow.IDIMPINSPRO = "2";
        //widget.currentRow.IDPROCPROD = "E";
    };
    
    this.verificaIDTPRESPINSP = function(widget){
        var IDTPRESPINSP = widget.parent.currentRow.IDTPRESPINSP;
        if(IDTPRESPINSP == "NADA"){
            widget.getField('VRPONTRESINS').isVisible = true;
            widget.getField('VRPONTRESINS').showOnList = true;
            widget.getField('VRPONTRESINS').reload();
        
            widget.getField('IDFAIXRESINS').isVisible = false;
            widget.getField('IDFAIXRESINS').reload();
            widget.getField('VRINIFAIXRES').isVisible = false;
            widget.getField('VRINIFAIXRES').reload();
            widget.getField('VRFINFAIXRES').isVisible = false;
            widget.getField('VRFINFAIXRES').reload();
            widget.getField('date_DTINIFAIXRES').isVisible = false;
            widget.getField('date_DTINIFAIXRES').reload();
            widget.getField('date_DTFINFAIXRES').isVisible = false;
            widget.getField('date_DTFINFAIXRES').reload();
            widget.getField('time_DTINIFAIXRES').isVisible = false;
            widget.getField('time_DTINIFAIXRES').reload();
            widget.getField('time_DTFINFAIXRES').isVisible = false;
            widget.getField('time_DTFINFAIXRES').reload();
            widget.getField('datetime_DTINIFAIXRES').isVisible = false;
            widget.getField('datetime_DTINIFAIXRES').reload();
            widget.getField('datetime_DTFINFAIXRES').isVisible = false;
            widget.getField('datetime_DTFINFAIXRES').reload();
        
        } else if(IDTPRESPINSP == "TEXT"){
            widget.getField('VRPONTRESINS').isVisible = true;
            widget.getField('VRPONTRESINS').showOnList = true;
            widget.getField('VRPONTRESINS').reload();
        
            widget.getField('IDFAIXRESINS').isVisible = false;
            widget.getField('IDFAIXRESINS').reload();
            widget.getField('VRINIFAIXRES').isVisible = false;
            widget.getField('VRINIFAIXRES').reload();
            widget.getField('VRFINFAIXRES').isVisible = false;
            widget.getField('VRFINFAIXRES').reload();
            widget.getField('date_DTINIFAIXRES').isVisible = false;
            widget.getField('date_DTINIFAIXRES').reload();
            widget.getField('date_DTFINFAIXRES').isVisible = false;
            widget.getField('date_DTFINFAIXRES').reload();
            widget.getField('time_DTINIFAIXRES').isVisible = false;
            widget.getField('time_DTINIFAIXRES').reload();
            widget.getField('time_DTFINFAIXRES').isVisible = false;
            widget.getField('time_DTFINFAIXRES').reload();
            widget.getField('datetime_DTINIFAIXRES').isVisible = false;
            widget.getField('datetime_DTINIFAIXRES').reload();
            widget.getField('datetime_DTFINFAIXRES').isVisible = false;
            widget.getField('datetime_DTFINFAIXRES').reload();
    
        } else if(IDTPRESPINSP == "VALR"){
            widget.getField('IDFAIXRESINS').isVisible = true;
            widget.getField('IDFAIXRESINS').showOnList = true;
            widget.getField('IDFAIXRESINS').reload();
            widget.getField('VRINIFAIXRES').isVisible = true;
            widget.getField('VRINIFAIXRES').showOnList = true;
            widget.getField('VRINIFAIXRES').reload();
            widget.getField('VRFINFAIXRES').isVisible = true;
            widget.getField('VRFINFAIXRES').showOnList = true;
            widget.getField('VRFINFAIXRES').reload();
            widget.getField('VRPONTRESINS').isVisible = true;
            widget.getField('VRPONTRESINS').showOnList = true;
            widget.getField('VRPONTRESINS').reload();
        
            widget.getField('date_DTINIFAIXRES').isVisible = false;
            widget.getField('date_DTINIFAIXRES').reload();
            widget.getField('date_DTFINFAIXRES').isVisible = false;
            widget.getField('date_DTFINFAIXRES').reload();
            widget.getField('time_DTINIFAIXRES').isVisible = false;
            widget.getField('time_DTINIFAIXRES').reload();
            widget.getField('time_DTFINFAIXRES').isVisible = false;
            widget.getField('time_DTFINFAIXRES').reload();
            widget.getField('datetime_DTINIFAIXRES').isVisible = false;
            widget.getField('datetime_DTINIFAIXRES').reload();
            widget.getField('datetime_DTFINFAIXRES').isVisible = false;
            widget.getField('datetime_DTFINFAIXRES').reload();
        
        } else if(IDTPRESPINSP == "DATA"){
            widget.getField('date_DTINIFAIXRES').isVisible = true;
            widget.getField('date_DTINIFAIXRES').showOnList = true;
            widget.getField('date_DTINIFAIXRES').reload();
            widget.getField('date_DTFINFAIXRES').isVisible = true;
            widget.getField('date_DTFINFAIXRES').showOnList = true;
            widget.getField('date_DTFINFAIXRES').reload();
            
            widget.getField('IDFAIXRESINS').isVisible = false;
            widget.getField('IDFAIXRESINS').reload();
            widget.getField('VRINIFAIXRES').isVisible = false;
            widget.getField('VRINIFAIXRES').reload();
            widget.getField('VRFINFAIXRES').isVisible = false;
            widget.getField('VRFINFAIXRES').reload();
            widget.getField('VRPONTRESINS').isVisible = false;
            widget.getField('VRPONTRESINS').reload();
            widget.getField('time_DTINIFAIXRES').isVisible = false;
            widget.getField('time_DTINIFAIXRES').reload();
            widget.getField('time_DTFINFAIXRES').isVisible = false;
            widget.getField('time_DTFINFAIXRES').reload();
            widget.getField('datetime_DTINIFAIXRES').isVisible = false;
            widget.getField('datetime_DTINIFAIXRES').reload();
            widget.getField('datetime_DTFINFAIXRES').isVisible = false;
            widget.getField('datetime_DTFINFAIXRES').reload();
        
        } else if(IDTPRESPINSP == "HORA"){
            widget.getField('time_DTINIFAIXRES').isVisible = true;
            widget.getField('time_DTINIFAIXRES').showOnList = true;
            widget.getField('time_DTINIFAIXRES').reload();
            widget.getField('time_DTFINFAIXRES').isVisible = true;
            widget.getField('time_DTFINFAIXRES').showOnList = true;
            widget.getField('time_DTFINFAIXRES').reload();
            
            widget.getField('IDFAIXRESINS').isVisible = false;
            widget.getField('IDFAIXRESINS').reload();
            widget.getField('VRINIFAIXRES').isVisible = false;
            widget.getField('VRINIFAIXRES').reload();
            widget.getField('VRFINFAIXRES').isVisible = false;
            widget.getField('VRFINFAIXRES').reload();
            widget.getField('VRPONTRESINS').isVisible = false;
            widget.getField('VRPONTRESINS').reload();
            widget.getField('date_DTINIFAIXRES').isVisible = false;
            widget.getField('date_DTINIFAIXRES').reload();
            widget.getField('date_DTFINFAIXRES').isVisible = false;
            widget.getField('date_DTFINFAIXRES').reload();
            widget.getField('datetime_DTINIFAIXRES').isVisible = false;
            widget.getField('datetime_DTINIFAIXRES').reload();
            widget.getField('datetime_DTFINFAIXRES').isVisible = false;
            widget.getField('datetime_DTFINFAIXRES').reload();
            
        } else if(IDTPRESPINSP == "DTHR"){
            widget.getField('datetime_DTINIFAIXRES').isVisible = true;
            widget.getField('datetime_DTINIFAIXRES').showOnList = true;
            widget.getField('datetime_DTINIFAIXRES').reload();
            widget.getField('datetime_DTFINFAIXRES').isVisible = true;
            widget.getField('datetime_DTFINFAIXRES').showOnList = true;
            widget.getField('datetime_DTFINFAIXRES').reload();
            
            widget.getField('IDFAIXRESINS').isVisible = false;
            widget.getField('IDFAIXRESINS').reload();
            widget.getField('VRINIFAIXRES').isVisible = false;
            widget.getField('VRINIFAIXRES').reload();
            widget.getField('VRFINFAIXRES').isVisible = false;
            widget.getField('VRFINFAIXRES').reload();
            widget.getField('VRPONTRESINS').isVisible = false;
            widget.getField('VRPONTRESINS').reload();
            widget.getField('time_DTINIFAIXRES').isVisible = false;
            widget.getField('time_DTINIFAIXRES').reload();
            widget.getField('time_DTFINFAIXRES').isVisible = false;
            widget.getField('time_DTFINFAIXRES').reload();
            widget.getField('date_DTINIFAIXRES').isVisible = false;
            widget.getField('date_DTINIFAIXRES').reload();
            widget.getField('date_DTFINFAIXRES').isVisible = false;
            widget.getField('date_DTFINFAIXRES').reload();
        
        }
    };
    
    this.saveOpcao = function(widget){
        if(widget.currentRow.date_DTINIFAIXRES || widget.currentRow.date_DTFINFAIXRES){
            widget.currentRow.DTINIFAIXRES = widget.currentRow.date_DTINIFAIXRES;
            widget.currentRow.DTFINFAIXRES = widget.currentRow.date_DTFINFAIXRES;
        } else if(widget.currentRow.time_DTINIFAIXRES || widget.currentRow.time_DTFINFAIXRES){
            widget.currentRow.DTINIFAIXRES = moment(moment().format("DD/MM/YYYY")+" "+widget.currentRow.time_DTINIFAIXRES, "DD/MM/YYYY HH:mm:ss").format("DD/MM/YYYY HH:mm:ss");
            widget.currentRow.DTFINFAIXRES = moment(moment().format("DD/MM/YYYY")+" "+widget.currentRow.time_DTFINFAIXRES, "DD/MM/YYYY HH:mm:ss").format("DD/MM/YYYY HH:mm:ss");
        } else if(widget.currentRow.datetime_DTINIFAIXRES || widget.currentRow.time_DTFINFAIXRES){
            widget.currentRow.DTINIFAIXRES = widget.currentRow.datetime_DTINIFAIXRES;
            widget.currentRow.DTFINFAIXRES = widget.currentRow.datetime_DTFINFAIXRES;
        }
        General.saveCrud(widget);
    };
    
    this.fieldHourAplly = function(widget){
        var IDTPRESPINSP = widget.parent.currentRow.IDTPRESPINSP;
        if(IDTPRESPINSP == "DATA"){
            widget.dataSource.data.forEach( function(element){
                if(element.DTINIFAIXRES){
                    element.date_DTINIFAIXRES = moment(element.DTINIFAIXRES).format("DD/MM/YYYY");
                }
                if(element.DTFINFAIXRES){
                    element.date_DTFINFAIXRES = moment(element.DTFINFAIXRES).format("DD/MM/YYYY");
                }
            });
            
        } else if(IDTPRESPINSP == "HORA"){
            widget.dataSource.data.forEach( function(element){
                if(element.DTINIFAIXRES){
                    element.time_DTINIFAIXRES = moment(element.DTINIFAIXRES, "DD/MM/YYYY HH:mm:ss" ).format("HH:mm");
                }
                if(element.DTFINFAIXRES){
                    element.time_DTFINFAIXRES = moment(element.DTFINFAIXRES, "DD/MM/YYYY HH:mm:ss" ).format("HH:mm");
                }
            });
      
        } else if(IDTPRESPINSP == "DTHR"){
           widget.dataSource.data.forEach( function(element){
                if(element.DTINIFAIXRES){
                    element.datetime_DTINIFAIXRES = element.DTINIFAIXRES;
                }
                if(element.DTFINFAIXRES){
                    element.datetime_DTFINFAIXRES = element.DTFINFAIXRES;
                }
            });
        
        }
        
    };
    
    
    
}
Configuration(function(ContextRegister) {
    ContextRegister.register('Ger11800_inspecao_Controller', Ger11800_inspecao_Controller);
});