function cdp02200_grupo_de_equipamentoController (ZHPromise, templateManager, restEngine, General, ScreenService, cdp02200_grupo_de_equipamentoService){
    
    this.newGrupo = function(widget){
        widget.newRow();
        
        widget.widgets[0].enabled = false;
        widget.getField('CDGRUPOEQUIPA').readOnly= false;
    };
    
    this.saveGrupo = function(widget){
        widget.widgets[0].enabled = true;
        
        General.saveCrud(widget);
    };
    
    this.editGrupo = function(widget){
        widget.widgets[0].enabled = false;
        widget.getField('CDGRUPOEQUIPA').readOnly= true;
       
        General.edit(widget);
    };
    
    this.CancelGrupo = function(widget){
        widget.widgets[0].enabled = true;
    };
    
    this.deleteGrupo = function(widget){
        
       ScreenService.confirmMessage(ScreenService.i18n('Delete Register?'), 'question', function (success) {
    
            cdp02200_grupo_de_equipamentoService.deletarGrupo(widget.currentRow).then(
                function(Success) {
                    ScreenService.closeSwipe().then(function () {
                        widget.activate();
                    });
                    widget.reload();
                },
                function(error){
                    if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
                        ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
                    } else {
                        ScreenService.showMessage(error.message);
                    }
                }
            );
        });
    };
    
    this.newEquipamento = function(widget){
        widget.newRow();
    };
    
    this.saveComplete = function(widget){
        widget.currentRow.__is_new = false;
    	widget.currentRow.changed = true;
        widget.currentRow.CDGRUPOEQUIPA = widget.parent.currentRow.CDGRUPOEQUIPA;
        
        cdp02200_grupo_de_equipamentoService.retornaFilial().then(function(filialLogada){
            widget.currentRow.CDFILIAL =  filialLogada[0].CDFILIAL;
        });
        General.saveCrud(widget);
    };
    
    this.editEquipamento = function(widget){
        widget.currentRow.CDGRUPOEQUIPA = null;
        widget.saveRow();
        
        General.edit(widget);
    };
    
    this.deleteEquipamento = function(widget){
        var deferred = ZHPromise.defer();
        ScreenService.confirmMessage(ScreenService.i18n('Delete Register?'), 'question', function (success) {
            widget.currentRow.__is_new = false;
        	widget.currentRow.changed = true;
            widget.currentRow.CDGRUPOEQUIPA = null;
            widget.currentRow.CDFILIAL =  null; 
            General.saveCrud(widget).then(function () {
                ScreenService.closeSwipe().then(function () {
					widget.activate();
					widget.reload();
					deferred.resolve();
				});
			});
		});
		return deferred.promise;
    };
    
}
Configuration(function(ContextRegister) {
    ContextRegister.register('cdp02200_grupo_de_equipamentoController', cdp02200_grupo_de_equipamentoController);
});
