function cdp06100_tarefas_da_producao_Controller (templateManager, restEngine, General, ScreenService, ZHPromise, cdp06100_tarefas_da_producao_Service){
    
    var self = this;
    var BKP_CurrentRow_Dados;
    
    this.changeDtfinrealaudReadOnlyOnFilter = function (widget){
        if(parseInt(widget.currentRow.IDSTATUSAUDI[0]) > 3)
            widget.getField('DTFINREALAUD').readOnly = false;
        else
            widget.getField('DTFINREALAUD').readOnly = true;
    };
    
    this.setFilter = function(widget){
        
        validateNrordprod(widget);
        
        validateCdsetexecaud(widget);
        
        validateIdstatusaudi(widget);
        
        validateDtinclaudit(widget);
        
        validateDtfinrealaud(widget);
        
        validateCdplanprodop(widget);
        
        validateTurno(widget);
        
        templateManager.container.getWidget('grid_dados').dataSourceFilter = [
                        {
                            "name": "P_PESQTURNO",
                            "operator": "=",
                            "value": widget.currentRow.P_PESQTURNO
                        },
                        {
                            "name": "P_CDFILIAL",
                            "operator": "=",
                            "value": getLocalVar('CDFILIAL')
                        },
                        {
                            "name": "P_NRORDPROD",
                            "operator": "=",
                            "value": widget.currentRow.P_NRORDPROD
                        },
                        {
                            "name": "P_TNRORDPROD",
                            "operator": "=",
                            "value": widget.currentRow.P_TNRORDPROD
                        },
                        {
                            "name": "P_CDSETEXECAUD",
                            "operator": "=",
                            "value": widget.currentRow.P_CDSETEXECAUD
                        },
                        {
                            "name": "P_TCDSETEXECAUD",
                            "operator": "=",
                            "value": widget.currentRow.P_TCDSETEXECAUD
                        },
                        {
                            "name": "P_IDSTATUSAUDI",
                            "operator": "=",
                            "value": widget.currentRow.P_IDSTATUSAUDI
                        },
                        {
                            "name": "P_DTINIC",
                            "operator": "=",
                            "value": widget.currentRow.P_DTINIC
                        },
                        {
                            "name": "P_DTFIMC",
                            "operator": "=",
                            "value": widget.currentRow.P_DTFIMC
                        },
                        {
                            "name": "P_TODOS",
                            "operator": "=",
                            "value": widget.currentRow.P_TODOS
                        },
                        {
                            "name": "P_DTINI",
                            "operator": "=",
                            "value": widget.currentRow.P_DTINI
                        },
                        {
                            "name": "P_DTFIM",
                            "operator": "=",
                            "value": widget.currentRow.P_DTFIM
                        },
                        {
                            "name": "P_ETODOS",
                            "operator": "=",
                            "value": widget.currentRow.P_ETODOS
                        },
                        {
                            "name": "P_CDPLANPRODOP",
                            "operator": "=",
                            "value": widget.currentRow.P_CDPLANPRODOP
                        },
                        {
                            "name": "P_LTURNOS",
                            "operator": "=",
                            "value": widget.currentRow.P_LTURNOS
                        },
                        {
                            "name": "P_TTURNOS",
                            "operator": "=",
                            "value": widget.currentRow.P_TTURNOS
                        },
                        {
                            "name": "NRORG",
                            "operator": "=",
                            "value": getLocalVar('NRORG')
                        }
                    ];
                    
    };
    
    function validateNrordprod (widget){
        var P_NRORDPROD = '', P_TNRORDPROD;
        if(!Util.isEmptyOrBlank(widget.currentRow.OP_SUBOP)){
            P_NRORDPROD = '_';
            widget.currentRow.OP_SUBOP.forEach(function (data){
                P_NRORDPROD = P_NRORDPROD.concat(data.concat('_')).replace(/\\/g, "/");
            });
            P_TNRORDPROD= null;
        }
        else {
            P_TNRORDPROD = 'T';
            P_NRORDPROD = null;
        }
        
        widget.currentRow.P_TNRORDPROD = P_TNRORDPROD;
        widget.currentRow.P_NRORDPROD = P_NRORDPROD;
    }
    
    function validateCdsetexecaud (widget){
        var P_CDSETEXECAUD = '', P_TCDSETEXECAUD;
        if(!Util.isEmptyOrBlank(widget.currentRow.NMSETOR)){
            widget.currentRow.NMSETOR.forEach(function (data){
                P_CDSETEXECAUD = P_CDSETEXECAUD.concat(data.concat('_'));
            });
            P_TCDSETEXECAUD= null;
        }
        else {
            P_TCDSETEXECAUD = 'T';
            P_CDSETEXECAUD = null;
        }
        
        widget.currentRow.P_TCDSETEXECAUD = P_TCDSETEXECAUD;
        widget.currentRow.P_CDSETEXECAUD = P_CDSETEXECAUD;
    }
    
    this.validateCdsetexecaudComplete =  function(widget){
        widget.dataSourceFilter = widget.dataSourceFilter.filter(function(element, index){
            return  ((element.name == "P_PESQTURNO") ||
            (element.name == "P_CDFILIAL") ||
            (element.name == "P_NRORDPROD") ||
            (element.name == "P_TNRORDPROD") ||
            (element.name == "P_CDSETEXECAUD") ||
            (element.name == "P_TCDSETEXECAUD") ||
            (element.name == "P_IDSTATUSAUDI") ||
            (element.name == "P_DTINIC") ||
            (element.name == "P_DTFIMC") ||
            (element.name == "P_TODOS") ||
            (element.name == "P_DTINI") ||
            (element.name == "P_DTFIM") || 
            (element.name == "P_ETODOS") || 
            (element.name == "P_CDPLANPRODOP") || 
            (element.name == "P_LTURNOS") || 
            (element.name == "P_TTURNOS") || 
            (element.name == "NRORG"));
        });
    };
    
    function validateIdstatusaudi (widget){
        var P_IDSTATUSAUDI = '_';
        if(!Util.isEmptyOrBlank(widget.currentRow.IDSTATUSAUDI)){
            widget.currentRow.IDSTATUSAUDI.forEach(function (data){
                P_IDSTATUSAUDI = P_IDSTATUSAUDI.concat(data.toString().concat('_'));
            });
        }
        else {
            P_IDSTATUSAUDI = '1_2_3_4_5';
        }
        widget.currentRow.P_IDSTATUSAUDI = P_IDSTATUSAUDI;
    }
    
    function validateDtinclaudit (widget){
        var P_DTINI = '', P_DTFIM, P_ETODOS;
        if(!Util.isEmptyOrBlank(widget.currentRow.DTINCLAUDIT)){
            if(!!widget.currentRow.DTINCLAUDIT.start && !!widget.currentRow.DTINCLAUDIT.end){
                P_DTINI = moment(widget.currentRow.DTINCLAUDIT.start+" 00:00:00", "DD/MM/YYYY HH:mm:ss").format("DD/MM/YYYY HH:mm:ss");
                P_DTFIM = moment(widget.currentRow.DTINCLAUDIT.end+" 23:59:59", "DD/MM/YYYY HH:mm:ss").format("DD/MM/YYYY HH:mm:ss");
                P_ETODOS = null;
            }
            else {
                P_DTINI = '30/12/1899';
                P_DTFIM = '30/12/1899';
                P_ETODOS = 'T';
            }
            
        } else {
            P_DTINI = '30/12/1899';
            P_DTFIM = '30/12/1899';
            P_ETODOS = 'T';
        }
            widget.currentRow.P_DTINI = P_DTINI;
            widget.currentRow.P_DTFIM = P_DTFIM;
            widget.currentRow.P_ETODOS = P_ETODOS;
    }
    
    function validateDtfinrealaud (widget){
        var P_DTINIC, P_DTFIMC, P_TODOS;
        if(!Util.isEmptyOrBlank(widget.currentRow.DTFINREALAUD)){
            if(!!widget.currentRow.DTFINREALAUD.start && !!widget.currentRow.DTFINREALAUD.end){
                P_DTINIC = moment(widget.currentRow.DTFINREALAUD.start+" 00:00:00", "DD/MM/YYYY HH:mm:ss").format("DD/MM/YYYY HH:mm:ss");
                P_DTFIMC = moment(widget.currentRow.DTFINREALAUD.end+" 23:59:59", "DD/MM/YYYY HH:mm:ss").format("DD/MM/YYYY HH:mm:ss");
                P_TODOS = null;
            }
            else {
                P_DTINIC = '30/12/1899';
                P_DTFIMC = '30/12/1899';
                P_TODOS = 'T';
            }
            
        } else {
            P_DTINIC = '30/12/1899';
            P_DTFIMC = '30/12/1899';
            P_TODOS = 'T';
        }
            widget.currentRow.P_DTINIC = P_DTINIC;
            widget.currentRow.P_DTFIMC = P_DTFIMC;
            widget.currentRow.P_TODOS = P_TODOS;
    }
    
    function validateCdplanprodop (widget) {
        var P_CDPLANPRODOP;
        if(!Util.isEmptyOrBlank(widget.currentRow.CDPLANPRODOP)){
            P_CDPLANPRODOP = widget.currentRow.CDPLANPRODOP;
        }
        else {
            P_CDPLANPRODOP = 'T';
        }
        widget.currentRow.P_CDPLANPRODOP = P_CDPLANPRODOP;
    }
    
    function validateTurno (widget) {
        var P_PESQTURNO = 'N', P_LTURNOS = null, P_TTURNOS = 'T';
        widget.currentRow.P_PESQTURNO = P_PESQTURNO;
        widget.currentRow.P_LTURNOS = P_LTURNOS;
        widget.currentRow.P_TTURNOS = P_TTURNOS;
    }
    
    this.alertCdplanprodopOnlyNull = function (widget){
        if (Util.isEmptyOrBlank(widget.dataSource.data)){
            ScreenService.showMessage("Não há Planos de Produção cadastrados");
        }
    };
    
    this.changeNmsetorIsVisible = function (widget){
        if (widget.currentRow.SETOR === 2){
            widget.getField('SETOR').class = 6;
            widget.getField('NMSETOR').isVisible = true;
        } else {
            widget.getField('SETOR').class = 12;
            widget.getField('NMSETOR').isVisible = false;
        }
    };
    
    this.changeOp_subopIsVisible = function (widget){
        if (widget.currentRow.NRORDPROD === 2){
            widget.getField('NRORDPROD').class = 6;
            widget.getField('OP_SUBOP').isVisible = true;
        } else {
            widget.getField('NRORDPROD').class = 12;
            widget.getField('OP_SUBOP').isVisible = false;
        }
    };
    
    this.formatText = function (widget){
        if (widget.currentRow.TXINSPECAUDI){
            var TXINSPECAUDI = widget.currentRow.TXINSPECAUDI;
            if ((TXINSPECAUDI.substr(TXINSPECAUDI.length - 9).split("}")[0]) === "\\par " ){
                TXINSPECAUDI = widget.currentRow.TXINSPECAUDI.split("}")[3];
                TXINSPECAUDI = TXINSPECAUDI.substr(TXINSPECAUDI.indexOf(" "));
                TXINSPECAUDI = TXINSPECAUDI.substr(0,TXINSPECAUDI.indexOf('\\par '));
            }
            widget.currentRow.TXINSPECAUDI = TXINSPECAUDI;
        }
    };
    
    this.validateIdrecuretaop = function (widget){
        clearVariables(widget);
        widget.redraw();
        self.validateOperador(widget);
        changeNmrecurso(widget);
        changeIdliberecuop(widget);
        changeNmgrupoequipa(widget);
    };
    
    function changeNmgrupoequipa (widget){
        if(widget.getField('IDRECURETAOP').value() === 'E'){
            widget.getField('NMGRUPOEQUIPA').readOnly = false;
            widget.getField('NMEQUIPPRO').readOnly = true;
        } else {
            
            widget.getField('NMGRUPOEQUIPA').readOnly = true;
        }
    }
    
    function changeIdliberecuop (widget){
        if(widget.getField('IDRECURETAOP').value() === 'E'){
            widget.getField('IDLIBERECUOP').readOnly = false;
        } else {
            widget.getField('IDLIBERECUOP').readOnly = true;
        }
    }
    
    function changeNmrecurso (widget){
        if(widget.getField('IDRECURETAOP').value() === 'E'){
            if(widget.getField('RECURSO')){
                widget.getField('RECURSO').name = "CDEQUIPPRO";
                widget.getField('NMRECURSO').name = "NMEQUIPPRO";
            }
            if (widget.getField('CDHABILIDADE')){
                widget.getField('CDHABILIDADE').name = "CDEQUIPPRO";
                widget.getField('NMHABILIDADE').name = "NMEQUIPPRO";
            }
            widget.getField('NMEQUIPPRO').descriptionField = "NMEQUIPPRO";
            widget.getField('NMEQUIPPRO').valueField = "CDEQUIPPRO";
            widget.getField('NMEQUIPPRO').order = "CDEQUIPPRO";
            widget.getField('NMEQUIPPRO').outData = {
                "NMEQUIPPRO":"NMEQUIPPRO",
                "CDEQUIPPRO":"CDEQUIPPRO"
            };
            widget.getField('NMEQUIPPRO').fields = [
                {
                    "sequenceInList":1,
                    "name":"CDEQUIPPRO",
                    "label": "Código",
                    "showOnList": true,
                    "isVisible":true,
                    "template":"field/text.html",
                    "mobile":{
                        "sequenceInList": 2
                    }
                },
                {
                    "sequenceInList":2,
                    "name":"NMEQUIPPRO",
                    "label":"Nome: ",
                    "align":"left",
                    "template":"field/text.html",
                    "isVisible":true,
                    "showOnList":true,
                    "showOnView":true,
                    "mobile":{
                        "sequenceInList": 1
                    }
                }
            ];
            widget.getField('NMEQUIPPRO').dataSource.name = "cdp#/crud/equipaprod";
            widget.getField('NMEQUIPPRO').readOnly = false;
        } else {
            if(widget.getField('RECURSO')){
                widget.getField('RECURSO').name = "CDHABILIDADE";
                widget.getField('NMRECURSO').name = "NMHABILIDADE";
            }
            if (widget.getField('CDEQUIPPRO')){
                widget.getField('CDEQUIPPRO').name = "CDHABILIDADE";
                widget.getField('NMEQUIPPRO').name = "NMHABILIDADE";
            }
            widget.getField('NMHABILIDADE').descriptionField = "NMHABILIDADE";
            widget.getField('NMHABILIDADE').valueField = "CDHABILIDADE";
            widget.getField('NMHABILIDADE').order = "CDHABILIDADE";
            widget.getField('NMHABILIDADE').outData = {
                "NMHABILIDADE":"NMHABILIDADE",
                "CDHABILIDADE":"CDHABILIDADE"
            };
            widget.getField('NMHABILIDADE').fields = [
                {
                    "sequenceInList":1,
                    "name":"CDHABILIDADE",
                    "label": "Código",
                    "showOnList": true,
                    "isVisible":true,
                    "template":"field/text.html",
                    "mobile":{
                        "sequenceInList": 2
                    }
                },
                {
                    "sequenceInList":2,
                    "name":"NMHABILIDADE",
                    "label":"Nome: ",
                    "align":"left",
                    "template":"field/text.html",
                    "isVisible":true,
                    "showOnList":true,
                    "showOnView":true,
                    "mobile":{
                        "sequenceInList": 1
                    }
                }
            ];
            widget.getField('NMHABILIDADE').dataSource.name = "cdp#/crud/habilidade";
            widget.getField('NMHABILIDADE').dataSourceFilter = [];
            widget.getField('NMHABILIDADE').readOnly = false;
            widget.getField('NMGRUPOEQUIPA').readOnly = true;
            widget.getField('NMGRUPOEQUIPA').setValue("");
        }
    }
    
    function clearVariables (widget){
        if(widget.getField('IDRECURETAOP').value() === 'E'){
            widget.currentRow.CDOPERADOR = "";
            widget.currentRow.NMOPERADOR = "";
            widget.currentRow.CDHABILIDADE = "";
            widget.currentRow.NMHABILIDADE = "";
        } else {
            widget.currentRow.CDGRUPOEQUIPA = "";
            widget.currentRow.NMGRUPOEQUIPA = "";
            widget.currentRow.CDEQUIPPRO = "";
            widget.currentRow.NMEQUIPPRO = "";
            widget.currentRow.IDLIBERECUOP = "";
        }
    }
    
    this.changeDataSourceFilterNmequippro = function (widget){
        widget.getField('NMEQUIPPRO').dataSourceFilter = [
            {
                "name": "CDGRUPOEQUIPA",
                "operator": "=",
                "value": General.getFieldValue('CDGRUPOEQUIPA', 'tabbed_liberacao')
            }
        ];
    };
    
    this.saveCrud = function(widget){
        if (widget.currentRow.__is_new){
            General.saveCrud(widget).then(function (){
                var widgetsToActivate = widget.parent.widgets;
    
    			General.changeWidgetAcessibility(
    				widgetsToActivate.filter(function (subwidget) {
    					return subwidget.name != widget.name;
    				}).concat(widget.parent), //retorna um array com a widget parent e suas widgets filhas, exceto aquela que será editada
    				true);
            });
        } else {
            General.widgetSave(widget).then(function (){
                var widgetsToActivate = widget.parent.widgets;
    
    			General.changeWidgetAcessibility(
    				widgetsToActivate.filter(function (subwidget) {
    					return subwidget.name != widget.name;
    				}).concat(widget.parent), //retorna um array com a widget parent e suas widgets filhas, exceto aquela que será editada
    				true);
            });
        }
    };
    
    this.backOrCancel = function(args){
        General.backOrCancel(args).then(function (){
            var widget = args.owner.widget;
            var widgetsToActivate = widget.parent.widgets;
    		General.changeWidgetAcessibility(
    		widgetsToActivate.filter(function (subwidget) {
    			return subwidget.name != widget.name;
    		}).concat(widget.parent), //retorna um array com a widget parent e suas widgets filhas, exceto aquela que será editada
    		true);
        });
    };
    
    this.cancelFormDados = function(args){
        General.backOrCancel(args).then(function (){
            var widget = args.owner.widget;
            var widgetsToActivate = widget.widgets;
    		General.changeWidgetAcessibility(
    		widgetsToActivate.filter(function (subwidget) {
    			return subwidget.name != widget.name;
    		}).concat(widget), //retorna um array com a widget parent e suas widgets filhas, exceto aquela que será editada
    		true);
        });
    };
    
    this.saveTabbedObservacoes = function (widget){
        if (Util.isEmptyOrBlank(widget.dataSource.data[0])){
            widget.currentRow.__is_new = true;
            widget.currentRow.CDFILIAL = General.getFieldValue('CDFILIAL', 'grid_dados');
            widget.currentRow.NRAUDITORIA = General.getFieldValue('NRAUDITORIA', 'grid_dados');
            widget.currentRow.NRINSPECAUDI = General.getFieldValue('NRINSPECAUDI', 'tabbed_tarefas');
        }
        var deferred = ZHPromise.defer();
        cdp06100_tarefas_da_producao_Service.salvarDescinsaudit(widget.currentRow).then(function(){
            if (General.formWidgetSwitchTemplate(widget) && widget.parent) {
                var widgetsToActivate = widget.parent.widgets;
        	
            	General.changeWidgetAcessibility(
            		widgetsToActivate.filter(function (subwidget) {
            			return subwidget.name != widget.parent.name;
            		}).concat(widget.parent), //retorna um array com a widget parent e suas widgets filhas, exceto aquela que será editada
            	true);
        		widget.list();
				deferred.resolve();
            }
        }, function (error){
            ScreenService.showMessage(error.data.error);
            deferred.reject();
        });
        return deferred.promise;
    };
    
    this.deleteTabbedObservacoes = function (widget){
        var deferred = ZHPromise.defer();
		ScreenService.confirmMessage(ScreenService.i18n('Delete Register?'), 'question', function (success) {
			widget.currentRow.TXINSPECAUDI = "";
			self.saveTabbedObservacoes(widget).then(function (){
			    General.formWidgetSwitchTemplate(widget);
			    widget.activate();
			    deferred.resolve();
			});
		}, function (error) {
			if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
				ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
			} else {
				ScreenService.showMessage(error.data.error);
			}
			deferred.reject();
		});
		return deferred.promise;
    };
    
    this.redraw  = function (){
        if (templateManager.container.getWidget('tabbed_liberacao').getField('IDRECURETAOP').value()){
            if (templateManager.container.getWidget('tabbed_liberacao').getField('IDRECURETAOP').value() === 'E'){
                templateManager.container.getActiveWidget().dataSource.name = "cdp#/crud/equipaprod";
                if (templateManager.container.getActiveWidget().getField('CDHABILIDADE')){
                    templateManager.container.getActiveWidget().fields[0].name = "CDEQUIPPRO";
                    templateManager.container.getActiveWidget().fields[1].name = "NMEQUIPPRO";
                }
            }
            if (templateManager.container.getWidget('tabbed_liberacao').getField('IDRECURETAOP').value() === 'H'){
                templateManager.container.getActiveWidget().dataSource.name = "cdp#/crud/habilidade";
                if (templateManager.container.getActiveWidget().getField('NMEQUIPPRO')){
                    templateManager.container.getActiveWidget().fields[0].name = "CDHABILIDADE";
                    templateManager.container.getActiveWidget().fields[1].name = "NMHABILIDADE";
                }
            }
            templateManager.container.getActiveWidget().reload();
        }
    };
    
    function formatTempoGastoForSave (widget, nameDtInicial, nameDtFinal, nameTmpGasto){
        if (!Util.isEmptyOrBlank(General.getFieldValue(nameDtFinal, widget.name)) && !Util.isEmptyOrBlank(General.getFieldValue(nameDtInicial, widget.name))){
            var one_hour=1000*60*60;
            var dataInicial = calcTempo (General.getFieldValue(nameDtInicial, widget.name).split(" "));
            var dataFinal = calcTempo (General.getFieldValue(nameDtFinal, widget.name).split(" "));
            var diffInMs = dataFinal - dataInicial;
            widget.getField(nameTmpGasto).setValue(diffInMs/one_hour);
        } else{
             widget.getField(nameTmpGasto).setValue('');
         }
    }
    
    this.formatTempoGastoOnChange = function(widget, nameDtInicial, nameDtFinal, nameTmpGasto){
        if (!Util.isEmptyOrBlank(General.getFieldValue(nameDtFinal, widget.name)) && !Util.isEmptyOrBlank(General.getFieldValue(nameDtInicial, widget.name))){
            var one_hour=1000*60*60;
            var one_minute =1000*60;
            var dataInicial = calcTempo (General.getFieldValue(nameDtInicial, widget.name).split(" "));
            var dataFinal = calcTempo (General.getFieldValue(nameDtFinal, widget.name).split(" "));
            var diffInMs = dataFinal - dataInicial;
            widget.getField(nameTmpGasto).setValue(formatTimeText(parseInt(diffInMs/one_hour)).concat(':'.concat(formatTimeText((diffInMs%one_hour)/one_minute))));
        } else{
            widget.getField(nameTmpGasto).setValue('');
        }
        
    };
    
    this.formatTempoGasto = function (widget, nameDtInicial, nameDtFinal, nameTmpGasto){
        widget.dataSource.data.forEach(function(data){
            if (!Util.isEmptyOrBlank(data[nameDtFinal]) && !Util.isEmptyOrBlank(data[nameDtInicial])){
                var one_hour=1000*60*60;
                var one_minute =1000*60;
                var dataInicial = calcTempo (data[nameDtInicial].split(" "));
                var dataFinal = calcTempo (data[nameDtFinal].split(" "));
                var diffInMs = dataFinal - dataInicial;
                data[nameTmpGasto]= (formatTimeText(parseInt(diffInMs/one_hour)).concat(':'.concat(formatTimeText((diffInMs%one_hour)/one_minute))));
            } else {
                data[nameTmpGasto]= '';
            }
        });
    };
    
    function calcTempo (DATA){
        var time = new Date(parseInt(DATA[0].split('/')[2]), (parseInt(DATA[0].split('/')[1])- 1), parseInt(DATA[0].split('/')[0]), parseInt(DATA[1].split(':')[0]), parseInt(DATA[1].split(':')[1]));
        return time;
    }
    
    function formatTimeText (tempo){
        if (tempo < 10)
            return '0'.concat(tempo.toString());
        else
            return tempo.toString();
    }
    
    this.setNmrecursoReadOnlyOnEquipamento = function (widget){
        if (widget.getField('NMGRUPOEQUIPA').value())
            widget.getField('NMEQUIPPRO').readOnly = false;
        else{
            widget.getField('NMEQUIPPRO').readOnly = true;
            widget.getField('NMEQUIPPRO').setValue("");
        }
    };
    
    this.validateOperador = function (widget){
        if(widget.getField('CDHABILIDADE'))
            if (!Util.isEmptyOrBlank(General.getFieldValue('CDHABILIDADE', 'tabbed_liberacao'))){
                widget.getField('NMOPERADOR').readOnly = false;
                widget.getField('NMOPERADOR').validations = {'required': true};
            } else {
                widget.getField('NMOPERADOR').validations = {};
                widget.getField('NMOPERADOR').readOnly = true;
                widget.getField('NMOPERADOR').setValue('');
                widget.getField('CDOPERADOR').setValue('');
            }
    };
    
    this.editTabbedLiberacao = function (widget){
        self.validateIdrecuretaop(widget);
        if(widget.getField('IDRECURETAOP').value() === 'E')
            self.setNmrecursoReadOnlyOnEquipamento(widget);
        else
            self.validateOperador(widget);
        General.widgetEdit(widget);
    };
    
    this.validateIdstatusaudiOnChange = function(widget){
        if (parseInt(widget.currentRow.NRAUDITORIA) === parseInt(BKP_CurrentRow_Dados.NRAUDITORIA)){
            if (parseInt(widget.currentRow.IDSTATUSAUDI) < parseInt(BKP_CurrentRow_Dados.IDSTATUSAUDI)){
                ScreenService.showMessage("Situação não pode voltar para Pendente").then(function(){
                    widget.currentRow.IDSTATUSAUDI = BKP_CurrentRow_Dados.IDSTATUSAUDI;
                    widget.redraw();
                });
            }
        }
    };
    
    this.setBkp_Currentrow_Dados = function (widget){
        BKP_CurrentRow_Dados = Util.clone(widget.currentRow);
    };
    
    this.saveWithTimeFormat = function (widget, nameDtInicial, nameDtFinal, nameTmpGasto){
        formatTempoGastoForSave(widget, nameDtInicial, nameDtFinal, nameTmpGasto);
        ZHPromise.all(self.saveCrud(widget)).then(function(success){
            this.formatTempoGasto(widget, nameDtInicial, nameDtFinal, nameTmpGasto);
            widget.reload();
        }.bind(this));
    };
    
    this.validateDtFinal = function (widget, nameDtInicial, nameDtFinal, nameTmpGasto){
        if (!Util.isEmptyOrBlank(General.getFieldValue(nameDtFinal, widget.name)) && !Util.isEmptyOrBlank(General.getFieldValue(nameDtInicial, widget.name))){
            var dataInicial = calcTempo (General.getFieldValue(nameDtInicial, widget.name).split(" "));
            var dataFinal = calcTempo (General.getFieldValue(nameDtFinal, widget.name).split(" "));
            if(dataInicial > dataFinal){
                ScreenService.showMessage(widget.getField(nameDtFinal).label.concat(" maior que ").concat(widget.getField(nameDtInicial).label));
                widget.getField(nameDtFinal).setValue('');
                widget.getField(nameTmpGasto).setValue('');
            }
        }
    };
    
    this.validateFinalTarefa = function (widget) {
        if (widget.getField('IDINSPCONC').value() === 'S'){
            templateManager.container.getWidget('tabbed_liberacao').reload().then(function (response){
                if (!Util.isEmptyOrBlank(response.dataset.recuretapaop_grupoequipa_roteiroProducao)){
                    var isIncomplete;
                    response.dataset.recuretapaop_grupoequipa_roteiroProducao.forEach(function (data){
                        if (!Util.isEmptyOrBlank(data.DTFINUTRECOP) && !Util.isEmptyOrBlank(data.DTINIUTRECOP)){
                        } else {
                            ScreenService.showMessage('Tarefa não pode ser concluída com recurso em aberto');
                            isIncomplete = true;
                            return 0;

                        }
                    });
                    if (!isIncomplete){
                        widget.currentRow.DTFINRINSAUD = moment(widget.currentRow.DTFINRINSAUD, "DD/MM/YYYY HH:MM:SS").format("DD/MM/YYYY HH:MM:SS");
                        widget.currentRow.DTFINRINSAUD = moment().format("DD/MM/YYYY HH:MM:SS");
                        self.saveWithTimeFormat(widget, 'DTINIRINSAUD', 'DTFINRINSAUD', 'QTHRINSAUD');
                    }
                } else {
                    ScreenService.showMessage('Tarefa não pode ser concluída sem recurso cadastrado');
                }
            });
        } 
        else {
            General.saveCrud(widget);
            widget.widgets.forEach(function (element) {
                element.enabled = true;
            });
        }
    };
    
    this.editDadosRoteiro = function (widget){
        General.widgetEdit(widget);
        if (General.getFieldValue('IDSTATUSAUDI', 'grid_dados') === '3' || General.getFieldValue('IDSTATUSAUDI', 'grid_dados') === '4'){
            widget.fields.forEach(function (field){
                field.readOnly = true;
            });
        } else {
            widget.getField('IDSTATUSAUDI').readOnly = false;
            widget.getField('NMSETOR').readOnly = false;
            widget.getField('DTINCLAUDIT').readOnly = false;
            widget.getField('DSREFEAUDIT').readOnly = false;
        }
    };
    
    this.saveTarefasSubWidgetAndChangeSituationOfRoteiro = function (widget){
        if (General.getFieldValue('IDSTATUSAUDI', 'grid_dados') === '1'){
            if (widget.name === 'tabbed_observacao'){
                saveObservacaoAndDados(widget);
            }
            if (widget.name === 'tabbed_liberacao'){
                saveLiberacaoAndDados(widget);
            }
            if (widget.name === 'tabbed_ocorrencia'){
                saveOcorrenciaAndDados(widget);
            }
        } else {
            
        }
    };
    
    function saveObservacaoAndDados (widget){
        templateManager.container.getWidget('grid_dados').getField('IDSTATUSAUDI').setValue('2');
        var dataSet = [widget.currentRow, templateManager.container.getWidget('grid_dados').currentRow];
        cdp06100_tarefas_da_producao_Service.saveObservacaoAndDados(dataSet);
    }
    
    function saveLiberacaoAndDados (widget){
        templateManager.container.getWidget('grid_dados').getField('IDSTATUSAUDI').setValue('2');
        var dataSet = [widget.currentRow, templateManager.container.getWidget('grid_dados').currentRow];
        cdp06100_tarefas_da_producao_Service.saveLiberacaoAndDados(dataSet);
    }
    
    function saveOcorrenciaAndDados (widget){
        templateManager.container.getWidget('grid_dados').getField('IDSTATUSAUDI').setValue('2');
        var dataSet = [widget.currentRow, templateManager.container.getWidget('grid_dados').currentRow];
        cdp06100_tarefas_da_producao_Service.saveOcorrenciaAndDados(dataSet);
    }
    
    this.changeEditAction = function(widget){
        widget.actions.forEach(function(element){
            if(element.name == "editar"){
                if (widget.currentRow.IDINSPCONC == 'S'){
                   element.isVisible = false; 
                } else if (widget.currentRow.IDINSPCONC == 'P'){
                   element.isVisible = true; 
                }
            }
        });
    };
    
}
Configuration(function(ContextRegister) {
    ContextRegister.register('cdp06100_tarefas_da_producao_Controller', cdp06100_tarefas_da_producao_Controller);
});