var cdp02200_grupo_de_equipamento_Repository = function (restEngine, localStorageEngine) {

    this.retornaUnidadeLogada = function() {
        var filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": "FILIAL_LOGADA"
            }
        ];
        return localStorageEngine.download("ger#/crud/filial", filter);
    };

    this.retornaOperadorLogado = function() {
        var filter = [
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": "OPERADOR_LOGADO"
            }
        ];
        return localStorageEngine.download("ger#/crud/operador", filter);
    };

    this.deletarGrupo = function(row) {
        return restEngine.post('cdp_producao#/DeletarGrupo', {
            "requestType": "Row",
            "row": row
        });
    };
};

Configuration(function(ContextRegister){
    ContextRegister.register('cdp02200_grupo_de_equipamento_Repository', cdp02200_grupo_de_equipamento_Repository);
});